// -----------------------------------------------------------------------
// COMPONENT - CLOCK
// -----------------------------------------------------------------------
Vue.component('datetime', {
  props: {
    area: {
      type: Object
    },
    parent: {
      type: Object
    },
    device_id: {
      type: String
    },
    factor_width: {
      type: Number
    },
    factor_height: {
      type: Number
    }
  },
  data: function () {
    return {
      fontFactor: 1,
      time: '',
      height_parent: 0,
      height: 0
    }
  },
  created: function () {
    var self = this
    // alert('clock')
  },
  mounted: function () {
    var self = this
    self.setup()
  },
  computed: {
    myVar: function () {
    }
  },
  methods: {
    setup: function () {
      var self = this
      if (self.area.config.font_size) self.fontFactor = self.area.config.font_size / 10
      if (!self.area.config.hour_format) self.area.config.hour_format = 'HH:MM:ss'
      self.formatShowDate()
      self.now()
      self.parent.createInterval(function () {
        self.now()
      }, 1000)
      setTimeout(function () {
        var main = self.$refs['main']
        if (main) {
          self.height = main.clientHeight
          self.height_parent = main.parentElement.parentElement.clientHeight
        }
      }, 200)
    },
    formatShowDate: function () {
      var self = this
      self.area.config.hour_format = self.area.config.hour_format.replace('DD','dd')
      self.area.config.hour_format = self.area.config.hour_format.replace('MM','mm')
      self.area.config.hour_format = self.area.config.hour_format.replace('YYYY','yyyy')
      self.area.config.hour_format = self.area.config.hour_format.replace(':mm',':MM')
      self.area.config.hour_format = self.area.config.hour_format.replace('mmMM','mmmm')
      self.area.config.hour_format = self.area.config.hour_format.replace('D ','dd ')
      self.area.config.hour_format = self.area.config.hour_format.replace('dD ','dd ')
    },
    now: function () {
      var self = this
      self.time = dateFormat(self.parent.curDate, self.area.config.hour_format)
      self.time = self.time.replace('#@#','<i style="font-size: 1em;" class="fas fa-calendar"></i>&nbsp;')
      self.time = self.time.replace('#$#','<i style="font-size: 1em;" class="fas fa-clock"></i>&nbsp;')
    }
  },
  watch: {
    'parent.playlistRestart': function (res) {
      var self = this
      // self.parent.debug('CLOCK - parent.playlistRestart')
      self.setup()
    }
  },
  template: '<div ref="main" :style="\'margin-top: \' + ((height_parent / 2) - (height / 2)) + \'px;\'">' +
  ' <center><table><tr :style="\'font-size: \' + (1.6 * fontFactor) + \'vh;\'">' +
  ' <td v-html="time"></td>' +
  ' </tr></table></center>' +
  '</div>'
})
// -----------------------------------------------------------------------
// END CLOCK
// -----------------------------------------------------------------------
