
// Wait for the deviceready event before using any of Cordova's device APIs.
// See https://cordova.apache.org/docs/en/latest/cordova/events/events.html#deviceready
document.addEventListener('deviceready', onDeviceReady, false)

// in cordova we need this or else we won't be able to exit the app when pressing
// the back button
document.addEventListener('backbutton', function(e) {
  e.preventDefault()
  navigator.app.exitApp()
  // navigator.app.backHistory()
})

/* window.addEventListener('keydown', function (e) {
  var key = e.key
  var altKey = e.altKey
  // alert('KEY1 = ' + key)
  if (altKey) {
    if (key == 'F4' || key == 'Tab') {
      e.preventDefault()
      return
    }
  }
}) */

function onDeviceReady() {
    // Cordova is now initialized. Have fun!
    startPlayer()
}

if (!window.hasOwnProperty('cordova')) {
  startPlayer()
}

function startPlayer () {
  // -----------------------------------------------------------------------
  // MAIN CODE
  // -----------------------------------------------------------------------
  new Vue({
    el: '#q-app',
    data: {
      androidFolder: 'Pictures',
      timerSetupGlobalPlaylist: undefined,
      timerBlink: undefined,
      blinkCount: 0,
      soundContext: new (window.AudioContext || window.webkitAudioContext)(),
      songs_to_play: [],
      sound_playing: false,
      calledFromKiosk: false,
      ua: navigator.userAgent.toUpperCase(),
      deviceId: '',
      deviceIdToPlay: '',
      prevKeyWasEnter: false,
      show: false,
      error: undefined,
      defaultPlayerPassword: 'mira',
      fieldIdx: 0,
      password: '',
      storeFoId: '',
      auxDeviceId: '',
      installToken: '',
      deviceConfig: {},
      bgColor: '',
      curPlaylistConfig: {},
      clickedLogo: false,
      f5Counter: 0,
      areas: [],
      baseWidth: 995,
      baseHeight: 560,
      baseWidthVertical: 664 * 1.5,
      baseHeightVertical: 1180 * 1.5,
      factor_width: 1,
      factor_height: 1,
      screenWidth: undefined,
      screenHeight: undefined,
      orientation: 'horizontal',
      hasInternet: false,
      kioskIp: undefined,
      kioskToken: '',
      ws: undefined,
      wsConnected: false,
      wsConfig: undefined,
      wsConfigConnected: false,
      validPlaylists: [],
      debugMsgs: [],
      apiUrl: 'apis.opalaconsult.com/queues_backoffice',
      http_method: window.hasOwnProperty('cordova') ? 'http://' : 'http://',
      ws_method: window.hasOwnProperty('cordova') ? 'ws://' : 'ws://',
      timerDebugHide: undefined,
      timerScreenshot: undefined,
      timercheckInternet: undefined,
      playlistPrevious: '',
      playlistIdx: 0,
      playlists: [],
      slideshowFilesInCache: {},
      playlistsCacheControl: {},
      playlistChangeControl: '',
      timeoutMaxDuration: undefined,
      timeoutPlaylistTimeout: undefined,
      timeoutStartPlayProcess: undefined,
      timeoutResizeReload: undefined,
      lastPlaylistNext: '',
      emptyContents: '',
      areaFiles: {},
      areaFilesNoFilters: {},
      // device info
      tvBrand: '',
      tvModelName: '',
      tvFirmwareVersion: '',
      tvUHD: '',
      tvSdkVersion: '',
      macEthernet: '',
      macWifi: '',
      db: undefined,
      hasDeviceInformation: false,
      curDate: new Date(),
      receivedDateFromWebsocket: false,
      timerStartDatetime: undefined,
      intervals: [],
      timeouts: [],
      slideshowSync: '',
      slideshowSyncTrigger: false,
      setupGlobalPlaylistTrigger: false,
      contentsChanged: false,
      lastNetworkState: undefined,
      electronKeyboardBuffer: '',
      wsMessage: undefined,
      hourAdjust: 0,
      playlistRestart: false,
      checkedDownloadFiles: {},
      playProcessStartedAlready: false,
      playListValidAreasByKey: {},
      playerUniqueUuid: '',
      createdWidgetIds: []
    },
    computed: {
      isLocalhost: function () {
        var self = this
        if (self.calledFromKiosk) {
          return false
        } else {
          return _.includes(window.location.href, '127.0.0.1')
        }
      },
      authPassword: function () {
        var self = this
        var password = self.defaultPlayerPassword.toUpperCase()
        if (self.storeFoId && self.deviceConfig.password_players != '' && self.deviceConfig.store_fo_id != '') {
          if (String(self.storeFoId) == String(self.deviceConfig.store_fo_id)) {
            password = self.deviceConfig.password_players.toUpperCase()
          }
        }
        return password
      },
      parent: function () {
        var self = this
        return self
      }
    },
    watch: {
      playlistsCacheControl: {
        handler: function (after, before) {
          var self = this
          // console.log('WATCH - playlistsCacheControl')
          if (Object.keys(after).length > 0) {
            // console.log('watch - playlistsCacheControl', after)
            self.startPlayProcess()
          }
        },
        deep: true
      },
      hasInternet: function (val) {
        var self = this
        if (val == false) {
          // no internet, kill websocket
          self.wsConfig = undefined
          self.wsConfigConnected = false
        } else {
          // we have internet, connect websocket
          self.webSocketConfigConnect()
        }
      }
    },
    mounted: function () {
      // var self = this
    },
    created: function () {
      var self = this

      /* if (window.location.protocol == 'https:') {
        // Current protocol is HTTPS, reload the page with HTTP
        var url = 'http://' + window.location.hostname + window.location.pathname + window.location.search
        window.open(url, "_blank")
      } */

      // this is used to make sure a widget receive messages from the payer
      // and processes only the correct instance
      self.playerUniqueUuid = self.generateUUID()

      // debug for js errors, if available
      if (window) {
        window.onerror = function (msg, url, line, col, error) {
          var arr = url.split('/')
          var file = arr[arr.length - 1]
          // self.debug('JS ERROR - file: ' + file + ', line: ' + line + ', msg: ' + msg + ', error: ' +  error, 'red')
          self.debug('JS ERROR: ' + file + ', line: ' + line + ' - ' + msg, 'red')

          // return true to prevent the default browser error handling
          return true
        }
      }

      /* window.onerror = function (msg, url, line, col, error) {
        var ep = {
          msg: msg || '',
          url: url || '',
          line: line || '',
          col: col || '',
          error: error || '',
          device_id: self.device_id || '',
          widget_id: self.widget_id || ''
        }

        var data = new URLSearchParams()

        console.log('!!!!!! JS ERROR !!!!!!')
        console.log(ep)

        for (var i in ep) {
          data.append(i, ep[i])
        }

        axios({
          url: `${self.url}/log_js_error`,
          data: data,
          method: 'POST'
        })

        var suppressErrorAlert = true
        // If you return true, then error alerts (like in older versions of
        // Internet Explorer) will be suppressed.
        return suppressErrorAlert
      } */

      // when player is called from kiosk, we receive this parameter, we need it
      // to isLocalhost to become false (only in screen box it needs to be true)
      if (self.queryParam('is_kiosk') == '1') {
        self.calledFromKiosk = true
      }

      // self.debug('self.http_method1 => ' + self.http_method)
      // self.debug('self.ws_method1 => ' + self.ws_method)

      if (! window.hasOwnProperty('cordova') && !self.isTizen() && !self.isWebOS()) {
        self.http_method = window.location.protocol + '//'
        if (self.http_method == 'https://') {
          self.ws_method = 'wss://'
        }
      }

      // self.debug('self.http_method2 => ' + self.http_method)
      // self.debug('self.ws_method2 => ' + self.ws_method)

      self.storeFoId = localStorage.getItem('miravision_store_fo_id') || ''
      self.auxDeviceId = localStorage.getItem('miravision_aux_device_id') || ''
      self.installToken = localStorage.getItem('miravision_install_token') || ''

      // reload page on screen resize
      window.addEventListener('resize', function () {
        if (self.$refs.store_fo_id_div.style.display == 'block') return
        this.clearTimeout(self.timeoutResizeReload)
        self.timeoutResizeReload = setTimeout(function () {
          self.debug('window resize - will reload')
          location.reload()
        }, 2000)
      })

      // document.addEventListener('keyup', self.handleKeyPress)
      window.addEventListener('keyup', self.handleKeyPress)

      self.db = localforage.createInstance({
        name: 'DB_Miravision_Config',
        version: 1.0,
        driver: [
          localforage.INDEXEDDB,
          localforage.LOCALSTORAGE,
          localforage.WEBSQL,
        ]
      })

      // -----------------------------------------------------------------------
      // in android, we write this file so we can have a confirmation to allow
      // access to write files from android
      if (self.isAndroid()) {
        self.cordovaFileExists(self.androidFolder, 'miravision')
        .then(function () {
          // file exists, means we already gave permission to write to disk
          // self.debug('File exists...')
        })
        .catch(function () {
          // self.debug('File dont exists...')
          var myblob = new Blob(['Miravision'], {
            type: 'text/plain'
          })
          self.cordovaWriteFile(self.androidFolder, 'miravision', myblob)
            .then(function () {
              // self.debug('File saved...')
            })
            .catch(function () {
              // self.debug('File error saving...')
            })
        })
      }
      // -----------------------------------------------------------------------

      /*
      if (self.isWebOS()) {
        setTimeout(function () {
          self.debug('self.macEthernet - ' + self.macEthernet)
          self.debug('self.macWifi - ' + self.macWifi)
          self.debug('self.tvModelName - ' + self.tvModelName)
          self.debug('self.tvUHD - ' + self.tvUHD)
          self.debug('self.tvSdkVersion - ' + self.tvSdkVersion)
          self.debug('self.tvFirmwareVersion - ' + self.tvFirmwareVersion) */

          /* idcap.request('idcap://time/onofftimer/add', {
            "parameters": {
              'type' : 'OFFTIMER',
              'hour' : 8,
              'minute' : 57,
              'week' : 127  // everyday
            },
            'onSuccess': function () {
              console.error('onSuccess')
            },
            'onFailure': function (err) {
              console.error('onFailure : errorMessage = ' + err.errorMessage)
            }
          })

        }, 1000)
      } */

      setTimeout(function () {
        self.takeScreenshot()
        clearInterval(self.timerScreenshot)
        self.timerScreenshot = setInterval(function () {
          self.takeScreenshot()
        }, self.getRandomInt(1200, 1800) * 1000)
      }, 10000)

      // this happens in android, when we turn remote off and we turn it back
      // on again
      document.addEventListener('resume', function () {
        // self.startAfterDeviceInformation()
        location.reload()
      }, false)

      setInterval(function () {
        if (navigator.onLine == false && self.hasInternet == true) {
          self.checkInternet()
        }
      }, 2000)

      self.checkInternet(true, true)
    },
    methods: {
      cordovaFileExists: function (path, filename) {
        const self = this
        return new Promise(function (resolve, reject) {
          window.resolveLocalFileSystemURL(cordova.file.externalRootDirectory, function (dirpar) {
            dirpar.getDirectory(path, { create: true }, function (dir) {
              dir.getFile(filename, { create: false, exclusive: false }, function (fileEntry) {
                fileEntry.getMetadata(function (metadata) {
                  /* {
                    modificationTime: '2022-07-26T16:36:31.000Z',
                    size: 903672
                    } */
                  if (metadata.size * 1 > 0) {
                    resolve()
                  } else {
                    reject()
                  }
                }, reject)
              }, reject)
            }, reject)
          }, reject)
        })
      },
      cordovaWriteFile: function (path, filename, blob) {
        var self = this
        return new Promise(function (resolve, reject) {
          window.resolveLocalFileSystemURL(cordova.file.externalRootDirectory, function (dirpar) {
            dirpar.getDirectory(path, { create: true }, function (dir) {
              dir.getFile(filename, { create: true, exclusive: false }, function (fileEntry) {
                // here comes
                fileEntry.createWriter(function (fileWriter) {
                  // append to the end
                  fileWriter.seek(fileWriter.length)
                  var finishedWriting = function () {
                    resolve(fileEntry)
                  }
                  var offset = 0
                  // var BLOCK_SIZE = 1 * 1024 * 1024 // write blocks of 1MB at a time
                  var BLOCK_SIZE = 1 * 5120 * 1024 // write blocks of 5MB at a time
                  var writeNext = function (finishCallback) {
                    var blockSize = Math.min(BLOCK_SIZE, blob.size - offset)
                    var block = blob.slice(offset, offset + blockSize)
                    fileWriter.onwriteend = function () {
                      if (offset > 0) {
                        if (!filename.includes('.__mira_completed')) {
                          if (parseInt(offset / 5120 / 1024) > 0) {
                            var arr = filename.split(';')
                          }
                        }
                      }
                      if (offset < blob.size) {
                        offset += blockSize
                        writeNext(finishCallback)
                      } else {
                        finishCallback()
                      }
                    }
                    fileWriter.write(block)
                  }
                  writeNext(finishedWriting)
                }, function (err) {
                  reject('error writing: ' + err)
                })
                // here finishes
              }, reject)
            }, reject)
          }, reject)
        })
      },
      setScreenBrightness: function () {
        var self = this
        if (self.isAndroid()) {
          // self.debug('Android brightness!!!')

          // var brightness = cordova.plugins.brightness

          // prevents sleep
          // brightness.setKeepScreenOn(true)

          // value should be float in range from 0 to 1.
          /* brightness.setBrightness(1,
            function () {
              // self.debug('brightness success...')
            },
            function (e) {
              // self.debug('brightness error...')
            }
          ) */
        } else if (self.isTizen()) {
          // var screenBrightness = tizen.power.getScreenBrightness()
          // self.debug("#" + screenBrightness + "#")

          // var arr = Object.keys(webapis.appcommon)
          // self.debug(JSON.stringify(arr))

          // var tvinfo = Object.keys(tizen.tvinfo)
          // self.debug(JSON.stringify(tvinfo))

          // var tvdisplaycontrol = Object.keys(tizen.tvdisplaycontrol)
          // self.debug(JSON.stringify(tvdisplaycontrol))

          // self.debug("#" + tizen + "#")
          // self.debug("#" + tizen.power + "#")

          /* tizen.tvwindow.show(
            function(success){
              self.debug('success')
            },
            function(fail){
              self.debug('fail')
            },
            ['0px', '0px', '50%', '540px'],
            'MAIN',
          ) */
        }
      },
      loadSound: function (soundUrl) {
        var self = this
        // self.debug('loadSound - ' + soundUrl)
        // console.log('loadSound', soundUrl)
        // console.log('self.soundContext', self.soundContext)
        var request = new XMLHttpRequest()
        request.open('GET', soundUrl, true)
        request.responseType = 'arraybuffer'
        request.onreadystatechange = function() {
          // self.debug('this.readyState - ' + this.readyState + ', this.status: ' + this.status)
          if (this.readyState == 4 && this.status == 200) {
            self.soundContext.decodeAudioData(request.response, function (buffer) {
              self.playSound(buffer)
            })
          }
        }
        request.send()
      },
      playSound: function (buffer) {
        var self = this
        // console.log('playSound')
        var source = self.soundContext.createBufferSource()
        source.onended = function () {
          self.songs_to_play.shift()
          if (self.songs_to_play.length) {
            self.loadSound(self.songs_to_play[0])
          } else {
            self.sound_playing = false
          }
        }
        source.buffer = buffer
        source.connect(self.soundContext.destination)
        source.start(0)
      },
      playSounds: function (sound, kiosk_ip) {
        var self = this
        var soundUrl = self.http_method + kiosk_ip
        if (self.isLocalhost) {
          soundUrl = self.http_method + '127.0.0.1'
        } else if (_.includes(window.location.href, 'opalaconsult.com')) {
          soundUrl = self.http_method + 'apis.opalaconsult.com'
        }
        if (sound == 'dingdong' || sound == 1) {
          self.songs_to_play.push(soundUrl + '/queues_backoffice/sounds/dingdong.mp3')
        } else {
          self.songs_to_play.push(soundUrl + '/queues_backoffice/sounds/' + sound + '.mp3')
        }
        if (self.songs_to_play.length && !self.sound_playing) {
          self.sound_playing = true
          self.songs_to_play.unshift(soundUrl + '/queues_backoffice/sounds/silence.mp3')
          self.loadSound(self.songs_to_play[0])
        }
      },
      wsPublishToWidgets: function (msg) {
        var self = this
        // ignore if we don't have a websocket defined
        if (!self.kioskIp) return
        _.forEach(self.createdWidgetIds, function (el, key) {
          msg.widget_id = el
          self.wsSend(msg)
        })
        /* _.forEach(self.createdIframes, function (el, key) {
          var elem = document.getElementById(el)
          // elem.contentWindow.postMessage(JSON.stringify(msg), 'https://apis.opalaconsult.com')
          elem.contentWindow.postMessage(JSON.stringify(msg), 'http://apis.opalaconsult.com')
        }) */
      },
      gotoNextField: function (prevElem, nextElem, idx) {
        var self = this
        if (prevElem.selectionStart == prevElem.value.length) {
          setTimeout(function () {
            nextElem.focus()
          }, 500)
          self.fieldIdx = idx
        }
      },
      startAfterDeviceInformation: function (calledFromDeviceAuxId, foundMapping) {
        var self = this
        // self.debug('startAfterDeviceInformation')
        if (calledFromDeviceAuxId) {
          self.startGetDeviceConfig()
        } else {
          self.getDeviceId()

          if (self.auxDeviceId) {
            self.getDeviceIdFromDeviceAuxId()
          } else {
            self.startGetDeviceConfig()
          }
        }
      },
      startGetDeviceConfig: function () {
        var self = this
        // self.debug('startGetDeviceConfig - ' + self.deviceId)
        if (self.deviceId) {
          self.getDeviceConfig()
        } else {
          self.showError('Couldnt get the device id')
        }
      },
      cfgFieldClick: function (idx) {
        var self = this
        self.fieldIdx = idx
      },
      handleKeyPress: function (e) {
        var self = this
        var keyCode = e.code

        if (! e.code && e.keyCode) {
          if (e.keyCode == 13) {
            keyCode = 'Enter'
          } else {
            keyCode = e.keyCode
          }
        }

        // self.debug('handleKeyPress - ' + e.code + ', ' + e.keyCode + ' => ' + keyCode)

        if (keyCode == '') return

        if (self.isElectron() && keyCode == 'F5') {
          self.f5Counter++
        }

        // in electron, if we press 5x in the F5 key, we show the config div
        if (self.f5Counter == 5) {
          self.f5Counter = 0
          self.showConfigDiv()
          return
        }

        // in android, if we're using a remote and we press "enter" while miravision
        // logo is visible, we activate the config div
        if (self.isAndroid() && (self.emptyContents || !self.hasDeviceInformation) && keyCode == 'Enter' && !self.clickedLogo) {
          self.handleLogoClick()
          return
        }

        if (self.isTizen()) {
          if (self.$refs.store_fo_id_div.style.display == 'block') {
            if (keyCode == 65376) {
              // after cycling fields, we save and reload
              if (self.fieldIdx == 3) {
                self.saveFieldsAndReload()
              } else {
                if (self.fieldIdx == 0) {
                  self.gotoNextField(self.$refs.password, self.$refs.store_fo_id, 1)
                } else if (self.fieldIdx == 1) {
                  self.gotoNextField(self.$refs.store_fo_id, self.$refs.aux_device_id, 2)
                } else if (self.fieldIdx == 2) {
                  self.gotoNextField(self.$refs.install_token, self.$refs.install_token, 3)
                } else if (self.fieldIdx == 3) {
                  self.gotoNextField(self.$refs.aux_device_id, self.$refs.password, 0)
                }
              }
            }
            return
          }
        }

        if (keyCode == 'Enter') {
          // in android emulator, when we press enter we get two enter key events
          // this code ignore the second one since for a second it allows only one
          if (self.isAndroid()) {
            if (self.prevKeyWasEnter) {
              return
            }

            self.prevKeyWasEnter = true
            setTimeout(function () {
              self.prevKeyWasEnter = false
            }, 1000)
          }

          if (self.isWebOS() || self.isElectron() || self.isAndroid()) {
            if (self.$refs.store_fo_id_div.style.display == 'block') {
              if (self.fieldIdx == 3) {
                self.saveFieldsAndReload()
              } else {
                if (self.fieldIdx == 0) {
                  self.gotoNextField(self.$refs.password, self.$refs.store_fo_id, 1)
                } else if (self.fieldIdx == 1) {
                  self.gotoNextField(self.$refs.store_fo_id, self.$refs.aux_device_id, 2)
                } else if (self.fieldIdx == 2) {
                  self.gotoNextField(self.$refs.install_token, self.$refs.install_token, 3)
                } else if (self.fieldIdx == 3) {
                  self.gotoNextField(self.$refs.aux_device_id, self.$refs.password, 0)
                }
              }
              return
            }
          }

          self.electronKeyboardBuffer = ''
          if (self.$refs.store_fo_id_div.style.display == 'block') {
            self.saveFieldsAndReload()
          } else {
            // in tizen and webos, we dont need a password to open config, we open here
            if (self.isTizen() || self.isWebOS()) {
              self.showConfigDiv()
            }
          }
        } else {
          self.electronKeyboardBuffer = self.electronKeyboardBuffer + String.fromCharCode(e.keyCode)
          // we ignore this until we've a device config
          if (self.deviceConfig && self.hasDeviceInformation) {
            if (self.electronKeyboardBuffer.toUpperCase() == self.authPassword) {
              self.electronKeyboardBuffer = ''
              self.showConfigDiv()
            }
          }
        }
      },
      appQuit: function () {
        var self = this
        var curPassword = self.$refs.password.value || ''
        if (String(curPassword.toUpperCase()) != String(self.authPassword)) {
          self.debug("Invalid password...", "red")
          return
        }
        if (self.isElectron()) {
          _cdvElectronIpc.quitApp()
        } else if (self.isAndroid()) {
          navigator.app.exitApp()
        } else {
          self.debug('Not supported...', 'red')
        }
      },
      closeConfig: function () {
        var self = this
        location.reload()
        // self.$refs.store_fo_id_div.style.display = 'none'
        // self.$refs.app_buttons.style.display = 'none'
      },
      saveFieldsAndReload: function () {
        var self = this
        var curPassword = self.$refs.password.value || ''
        if (String(curPassword.toUpperCase()) != String(self.authPassword)) {
          self.debug("Invalid password...", "red")
          return
        }
        localStorage.setItem('miravision_store_fo_id', self.$refs.store_fo_id.value)
        localStorage.setItem('miravision_aux_device_id', self.$refs.aux_device_id.value)
        localStorage.setItem('miravision_install_token', self.$refs.install_token.value)
        setTimeout(function () {
          location.reload()
        }, 500)
      },
      handleLogoClick: function () {
        var self = this
        // self.debug('handleLogoClick')
        // if (self.isAndroid() || self.isElectron()) {
        self.clickedLogo = true
        self.showConfigDiv()
        // }
      },
      showConfigDiv: function () {
        var self = this
        self.$refs.store_fo_id.value = self.storeFoId
        self.$refs.aux_device_id.value = self.auxDeviceId
        self.$refs.install_token.value = self.installToken
        self.$refs.store_fo_id_div.style.display = 'block'
        if (self.isAndroid() || self.isElectron() || self.isLinux()) {
          self.$refs.app_buttons.style.display = 'block'
        }
        // position config div
        var left = (self.$refs.main_div.offsetWidth / 2) - (self.$refs.store_fo_id_div.offsetWidth / 2)
        self.$refs.store_fo_id_div.style.left = left + 'px'
        var top = (self.$refs.main_div.offsetHeight / 2) - (self.$refs.store_fo_id_div.offsetHeight / 2)
        self.$refs.store_fo_id_div.style.top = top + 'px'
        setTimeout(function () {
          self.$refs.password.focus()
        }, 100)
      },
      restartSlideshows: function (e) {
        var self = this
        if (self.hasInternet) {
          // console.log('will emit - slideshow_restart - ', e)
          // self.debug('will send slideshow_restart to tag ' + e + ', ' + self.deviceConfig.store_uid)
          self.wsConfigSend('slideshow_restart', {
            'store_uid': self.deviceConfig.store_uid,
            'tag': e
          })
        }
      },
      wsConfigSend: function (action, params) {
        var self = this
        // console.log('params', params)
        if (!self.wsConfig) {
          console.log('cant call wsConfigSend, ws is not active...')
          return
        }
        if (self.wsConfig.readyState != 1) {
          console.log('cant call wsConfigSend, readyState is not 1 - ' + self.wsConfig.readyState)
        } else {
          var data = {
            origin: 'browser',
            action: action,
            device_id: self.deviceIdToPlay,
            target_device_id: self.deviceIdToPlay,
            params: params
          }
          self.wsConfig.send(JSON.stringify(data))
        }
      },
      wsSend: function (msg) {
        var self = this
        if (!self.ws) {
          console.log('cant call wsSend, ws is not active...')
          return
        }
        if (self.ws.readyState != 1) {
          console.log('cant call wsSend, readyState is not 1 - ' + self.ws.readyState)
        } else {
          // console.log('wsSend', msg)
          self.ws.send(JSON.stringify(msg))
        }
      },
      generateUUID: function () {
        function generateRandomHex () {
          return Math.floor((1 + Math.random()) * 0x10000)
            .toString(16)
            .substring(1)
        }

        return (
          generateRandomHex() +
          generateRandomHex() +
          '-' +
          generateRandomHex() +
          '-' +
          '4' + // Version 4 UUID
          generateRandomHex().substr(0, 3) +
          '-' +
          'a' + // set the four most significant bits of the 7th byte to 1010
          generateRandomHex().substr(0, 3) +
          '-' +
          generateRandomHex() +
          generateRandomHex() +
          generateRandomHex()
        )
      },
      takeScreenshot: function () {
        var self = this
        if (self.isTizen()) {
          self.tizenScreenshot()
        } else if (self.isAndroid()) {
          self.androidScreenshot()
        } else if (self.isWebOS()) {
          self.webOSScreenshot()
        } else if (self.isLinux()) {
          self.linuxScreenshot()
        }
      },

      tizenScreenshot: function () {
        var self = this
        if (self.isTizen() && _.includes(self.tvFirmwareVersion, '2.4')) {
          self.debug('tizenScreenshot - dont work in tizen 2.4')
        } else {
          self.html2canvasScreenshot()
        }
      },
      androidScreenshot: function () {
        var self = this
        self.html2canvasScreenshot()
      },
      webOSScreenshot: function () {
        var self = this
        // self.debug('webOSScreenshot - need to implement... - ' + self.tvFirmwareVersion)
        self.html2canvasScreenshot()
      },
      linuxScreenshot: function () {
        var self = this
        // self.debug('Linux screenshot wont be implemented here...')
        self.html2canvasScreenshot()
      },
      html2canvasScreenshot: function () {
        var self = this
        if (!self.hasInternet) return
        html2canvas(document.body, {
          allowTaint: true,
          logging: false,
          profile: true,
          useCORS: true
        }).then(function (canvas) {
          var xhr = new XMLHttpRequest()
          xhr.onreadystatechange = function () {
            if (xhr.readyState == XMLHttpRequest.DONE) {
              if (xhr.status == 200) {
                // self.debug('screenshot sent!')
              } else {
                // self.debug('screenshot error - ' + xhr.statusText)
              }
            }
          }
          var url = self.http_method + self.apiUrl + '/device_screenshot_collect'
          xhr.open('POST', url)
          xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded')
          var data = new URLSearchParams()
          data.append('device_id', self.deviceId)
          data.append('type', 'screen')
          data.append('is_server', '0')
          data.append('vpn_ip', '')
          data.append('kiosk_fo_id', '')
          data.append('config_from_js', JSON.stringify(self.deviceConfig))
          data.append('image_base64', canvas.toDataURL())
          xhr.send(data)
        })
      },
      tizenFileDelete: function (path, filename) {
        var self = this
        return new Promise(function (resolve, reject) {
          tizen.filesystem.resolve(
            path,
            function (dir) {
              dir.deleteFile(
                path + '/' + filename,
                function () {
                  resolve(filename)
                }, function (e) {
                  reject(e)
                }
              )
            }, function (e) {
              reject(e)
            },
            'rw'
          )
        })
      },
      getRandomInt: function (min, max) {
        min = Math.ceil(min)
        max = Math.floor(max)
        return Math.floor(Math.random() * (max - min)) + min
      },
      tizenDeleteAllContents: function () {
        var self = this
        tizen.filesystem.resolve(
          'downloads',
          function (dir) {
            dir.listFiles(function (files) {
              if (files.length == 0) {
                self.debug('TIZEN - NO FILES IN DEVICE...')
              } else {
                // self.debug('files - ' + files.length)
                for (var i=0; i<files.length; i++) {
                  var file = files[i]
                  var fname = file.name
                  // if (!fname.includes('.__mira_completed')) {
                  self.debug('TIZEN FILE IN HDD - ' + file.fileSize + ' - ' + file.name)
                  // }
                  self.tizenFileDelete('downloads', file.name).then(function (fileDeleted) {})
                }
              }
            })
          },
          function (e) {
            self.debug('Error - ' + e.message);
          },
          'rw'
        )
      },
      getDeviceInfo: function () {
        var self = this
        if (self.isTizen()) {
          self.tizenGetDeviceInfo()
        } else if (self.isAndroid() || self.isElectron()) {
          self.cordovaGetDeviceInfo()
        } else if (self.isWebOS()) {
          self.webOSGetDeviceInfo()
        } else if (self.isLinux()) {
          self.linuxGetDeviceInfo()
        }
      },
      linuxGetDeviceInfo: function () {
        var self = this
        self.tvBrand = 'LINUX'
        // self.tvFirmwareVersion = self.ua
        setTimeout(function () {
          self.hasDeviceInformation = true
          self.startAfterDeviceInformation()
        }, 2000)
      },
      tizenGetDeviceInfo: function () {
        var self = this
        self.tvBrand = 'SAMSUNG'
        var tizenObj
        try {
          tizenObj = tizen
        } catch (error) {
          self.hasDeviceInformation = true
          self.startAfterDeviceInformation()
        }
        if (tizenObj) {
          tizen.systeminfo.getPropertyValue(
            'WIFI_NETWORK',
            function (build) {
              var tmp = _.replace(build.macAddress, /:/g, '')
              self.macWifi = tmp.toUpperCase()
              // self.debug('getDeviceInfoTizen - macWifi - ' + self.macWifi)
            },
            function (error) {}
          )
          tizen.systeminfo.getPropertyValue(
            'ETHERNET_NETWORK',
            function (build) {
              var tmp = _.replace(build.macAddress, /:/g, '')
              self.macEthernet = tmp.toUpperCase()
              // self.debug('getDeviceInfoTizen - macEthernet - ' + self.macEthernet)
            },
            function (error) {}
          )
          tizen.systeminfo.getPropertyValue(
            'BUILD',
            function (build) {
              self.tvModelName = build.model
              self.tvFirmwareVersion = build.buildVersion
              self.tvUHD = ''
              self.tvSdkVersion = ''
              setTimeout(function () {
                self.hasDeviceInformation = true
                // self.debug('getDeviceInfoTizen - build - ' + build.model + ' - ' + build.buildVersion)
                self.startAfterDeviceInformation()
              }, 2000)
            },
            function (error) {}
          )
        }
      },
      webOSGetDeviceInfo: function () {
        var self = this
        self.tvBrand = 'LG'

        /* webOS.deviceInfo(function (device) {
          if (_.includes(device.modelName, 'SIMULATOR')) {
            self.deviceId = 'webos_simulator'
          }
        }) */

        webOS.service.request('luna://com.webos.service.sm', {
          method: 'deviceid/getIDs',
          parameters: {
            idType: ['LGUDID']
          },
          onSuccess: function (inResponse) {
            if (inResponse.hasOwnProperty('idList')) {
              self.deviceId = inResponse.idList[0].idValue
            }
          },
          onFailure: function (inError) {
            console.log('Failed to get system ID information')
            console.log('[' + inError.errorCode + ']: ' + inError.errorText)
            return
          },
        })

        webOS.service.request('luna://com.webos.service.systemservice', {
          method: 'getDeviceId',
          parameters: {},
          onSuccess: function(response) {
            self.deviceId = response.deviceId
          },
          onFailure: function(error) {
            // self.debug('Failed to retrieve device_ID:', error)
          }
        })

        webOS.service.request('luna://com.webos.service.connectionmanager', {
          method: 'getinfo',
          parameters: {},
          onSuccess: function (args) {
            self.macEthernet = args.wiredInfo.macAddress.replace(/:/g, '').toUpperCase()
            self.macWifi = args.wifiInfo.macAddress.replace(/:/g, '').toUpperCase()
          },
          onFailure: function (args) {
            // console.log('luna://com.webos.service.connectionmanager FAILED')
          }
        })

        webOS.service.request('luna://com.webos.service.tv.systemproperty', {
          method: 'getSystemInfo',
          parameters: {
            'keys': ['modelName', 'firmwareVersion', 'UHD', 'sdkVersion']
          },
          onComplete: function (inResponse) {
            var isSucceeded = inResponse.returnValue

            if (isSucceeded) {
              self.tvModelName = inResponse.modelName
              self.tvUHD = inResponse.UHD
              self.tvSdkVersion = inResponse.sdkVersion
              self.tvFirmwareVersion = inResponse.firmwareVersion
              setTimeout(function () {
                self.hasDeviceInformation = true
                self.startAfterDeviceInformation()
              }, 2000)
            } else {
                // console.log('Failed to get TV device information')
            }
          }
        })
      },
      cordovaGetDeviceInfo: function () {
        var self = this
        self.tvBrand = 'UNKNOWN'
        if (self.isAndroid()) {
          self.tvBrand = 'ANDROID'
        } else if (self.isElectron()) {
          self.tvBrand = 'ELECTRON'
          // self.debug('device.uuid - ' + device.uuid)
        }
        self.tvModelName = device.model
        self.tvUHD = device.manufacturer
        self.macEthernet = device.uuid.toUpperCase()
        self.macWifi = device.uuid.toUpperCase()
        self.sdkVersion = device.cordova
        self.tvFirmwareVersion = device.version
        setTimeout(function () {
          self.hasDeviceInformation = true
          self.startAfterDeviceInformation()
        }, 2000)
      },
      isTizen: function () {
        var self = this
        // return true
        if (self.ua.toUpperCase().indexOf('TIZEN') != -1) return true
        return false
      },
      isWebOS: function () {
        var self = this
        // return true
        if (self.ua.toUpperCase().indexOf('WEBOS') != -1 || self.ua.toUpperCase().indexOf('WEB0S') != -1) return true
        return false
      },
      isLinux: function () {
        var self = this
        // if (Platform.is.cordova) return true
        if (!self.isTizen() && !self.isWebOS() && !self.isAndroid()) {
          return true
        } else {
          return false
        }
      },
      isAndroid: function () {
        var self = this
        var isAndroid = false
        try {
          if (cordova.platformId == 'android') isAndroid = true
        } catch (e) {
        }
        return isAndroid
      },
      isElectron: function () {
        var self = this
        var isElectron = false
        try {
          if (cordova.platformId == 'electron') isElectron = true
        } catch (e) {
        }
        return isElectron
      },
      playlistNext: function (e) {
        var self = this
        // console.log('playlistNext', self.playlists.length)
        // console.log('lastPlaylistNext', self.lastPlaylistNext, e)
        if (self.playlists.length == 1) {
          self.playPlaylist(self.playlists[0])
        } else {
          // if (self.lastPlaylistNext != e) {
            self.lastPlaylistNext = e
            var nextIdx = self.playlistIdx + 1
            if (nextIdx > self.playlists.length - 1) nextIdx = 0
            self.playlistIdx = nextIdx
            // console.error('playlistIdx', self.playlistIdx)
            self.playPlaylist(self.playlists[self.playlistIdx])
          // }
        }
      },
      screenTo: function (e) {
        var self = this
        console.log('screenTo', e)
        var found = false
        _.forEach(self.playlists, function (el, key) {
          if (el.device_id == self.deviceIdToPlay) {
            if (el.config.draw_screen.description == e) {
              found = true
              self.playlistIdx = key
              self.playPlaylist(self.playlists[key])
            }
          }
        })
        if (!found) {
          self.debug(self.deviceIdToPlay + ' - Screen to not found - ' + e)
        }
      },
      debug: function (msg, color) {
        var self = this
        console.log(msg)
        if (!color) color = 'green-10'
        self.$q.notify({
          color: color,
          message: msg
        })
      },
      startDatetime: function () {
        var self = this
        // add one sec in the beginning which is the time the API took to answer back
        self.curDate.setSeconds(self.curDate.getSeconds() + 1)
        clearInterval(self.timerStartDatetime)
        self.timerStartDatetime = setInterval(function () {
          self.curDate.setSeconds(self.curDate.getSeconds() + 1)
          // console.log('curDate: ', dateFormat(self.curDate, 'yyyy-mm-dd HH:MM:ss'))
        }, 1000)
      },
      checkInternet: function (showInfo, onStart) {
        var self = this
        // console.log('checkInternet')
        // self.debug('checkInternet')
        var url = self.http_method + self.apiUrl + '/status'
        var xhr = new XMLHttpRequest()
        xhr.onerror = function () {
          if (showInfo || self.hasInternet) self.debug('No internet connection...')
          self.hasInternet = false
          // check internet every 60 seconds
          clearInterval(self.timercheckInternet)
          self.timercheckInternet = setInterval(function () {
            self.checkInternet(false)
          }, 5000)
          if (onStart) {
            self.getDeviceInfo()
          }
        }
        xhr.onreadystatechange = function () {
          if (xhr.readyState == XMLHttpRequest.DONE) {
            if (xhr.status == 200) {
              // self.debug('STATUS SUCCESS - ' + xhr.responseText)
              var ref = {}
              try {
                ref = JSON.parse(xhr.responseText)
              } catch (error) {
              }
              if (ref.success) {
                // means we lost internet and we recover again
                if (self.hasInternet == false && ! onStart) {
                  // self.hasInternet = true
                  // self.debug('We recovered internet connection')
                  self.debug('We recovered internet connection, will restart...')
                  setTimeout(function () {
                    location.reload()
                  }, 3000)
                  return
                }
                self.curDate = new Date(self.dateStrToObject(ref.datetime_str)) // keep date updated

                if (self.hourAdjust != 0) {
                  if (self.hourAdjust < 0) {
                    // console.log('subtract')
                    self.curDate.setHours(self.curDate.getHours() - Math.abs(self.hourAdjust));
                  } else {
                    // console.log('add')
                    self.curDate.setHours(self.curDate.getHours() + Math.abs(self.hourAdjust));
                  }
                }

                // self.debug('date adjust 2 - ' + ref.datetime_str + ' - ' + self.curDate)
                clearInterval(self.timercheckInternet)
                self.timercheckInternet = setInterval(function () {
                  self.checkInternet(false)
                }, self.getRandomInt(120, 300) * 1000)
                if (!self.timerStartDatetime) self.startDatetime()
                if (showInfo || !self.hasInternet) self.debug('We have internet connection...')
                self.hasInternet = true
                if (onStart) {
                  self.getDeviceInfo()
                }
              } else {
                if (showInfo || self.hasInternet) self.debug('No internet connection...')
                self.hasInternet = false
                // check internet every 60 seconds
                clearInterval(self.timercheckInternet)
                self.timercheckInternet = setInterval(function () {
                  self.checkInternet(false)
                }, 5000)
                if (onStart) {
                  self.getDeviceInfo()
                }
              }
            }
          }
        }
        xhr.open('POST', url)
        var data = new FormData()
        data.append('tv_brand', self.tvBrand)
        data.append('tv_firmware_version', self.tvFirmwareVersion)
        data.append('tv_sdk_version', self.tvSdkVersion)
        data.append('tv_uhd', self.tvUHD)
        data.append('tv_model_name', self.tvModelName)
        data.append('tv_device_id', self.deviceId)
        data.append('tv_mac_ethernet', self.macEthernet)
        data.append('tv_mac_wifi', self.macWifi)
        xhr.send(data)
      },
      getDeviceIdFromDeviceAuxId: function () {
        var self = this
        var url = self.http_method + self.apiUrl + '/device_id_from_aux_id'
        var xhr = new XMLHttpRequest()
        xhr.onerror = function () {
          self.debug('error on store_fo_id mapping - ' + self.auxDeviceId)
          self.startAfterDeviceInformation(true)
        }
        xhr.onreadystatechange = function () {
          if (xhr.readyState == XMLHttpRequest.DONE) {
            if (xhr.status == 200) {
              var ref = {}
              try {
                ref = JSON.parse(xhr.responseText)
              } catch (error) {
              }
              if (ref.success) {
                self.deviceId = ref.device_id
                var shortDeviceId = self.deviceId.substr(0, 3) + self.deviceId.substr(self.deviceId.length - 3, self.deviceId.length)
                self.debug(self.deviceId + ' - ' + shortDeviceId + ' - ' + window.screen.width + 'x' + window.screen.height + ' - aux_device_id: ' + self.auxDeviceId)
                self.startAfterDeviceInformation(true)
              } else {
                self.debug('didnt found aux_device_id mapping - ' + self.auxDeviceId)
                self.startAfterDeviceInformation(true)
              }
            }
          }
        }
        xhr.open('POST', url)
        var data = new FormData()
        data.append('aux_device_id', self.auxDeviceId)
        xhr.send(data)
      },
      genAreaStyle: function (area) {
        var self = this
        // console.log('genAreaStyle', area)
        var zIndex = area.config.z_index
        var bgColor = area.config.background_color || ''
        // console.log('genAreaStyle!! - zIndex: ' + zIndex)
        // when we've a queues area that identifiers a call, we can't apply the
        // bg color right away because it will be visible on call only
        if (area.type == 'queues' && area.config.type == 'call') {
          // if (area.config.text_call != '') {
          if (bgColor != '') {
            var tColor
            if (bgColor.includes('#')) {
              tColor = 'rgba(' + parseInt(bgColor.slice(1, 3), 16) + ',' +
                parseInt(bgColor.slice(3, 5), 16) + ',' +
                parseInt(bgColor.slice(5, 7), 16) + ',0)'
            } else {
              tColor = bgColor.replace(/[^,]+(?=\))/, '0');
            }
            if (tColor) bgColor = tColor
          }
          // }
        }
        var str = 'position: absolute; border-radius: ' + (area.config.border_radius) + 'vw; width: ' + (area.width * self.factor_width) + 'px; height: ' + (area.height * self.factor_height) + 'px; top: ' + (area.top * self.factor_height) + 'px; left: ' + (area.left * self.factor_width) + 'px; background-color: ' + (bgColor) + '; color: ' + (area.config.foreground_color) +'; border: 0px solid red; z-index: ' + zIndex + ';'
        // console.log('str', str)
        return str
      },
      doScreenClick: function () {
        var self = this
        var xhr = new XMLHttpRequest()
        xhr.timeout = 10000
        xhr.open('GET', 'http://127.0.0.1/screen/click')
        xhr.send()
      },
      playPlaylist: function (pl) {
        var self = this
        var configKey = pl.name
        var config = pl.config

        // we do this in linux boxes so videos can start wo user interaction
        if (self.isLocalhost) {
          self.doScreenClick()
        }

        // console.log('playPlaylist', pl)
        // self.debug('playPlaylist', pl)
        // make sure we reset these two timeouts when we start a playlist
        clearTimeout(self.timeoutPlaylistTimeout)
        clearTimeout(self.timeoutMaxDuration)

        self.getFactorUnit(config)

        // playlist has changed, reset intervals
        if (self.playlistPrevious != pl.device_id + '#' + pl.name) {
          _.forEach(self.intervals, function (interval) {
            clearInterval(interval)
          })
          self.intervals = []
          _.forEach(self.timeouts, function (timeout) {
            clearTimeout(timeout)
          })
          self.timeouts = []
        }

        self.curPlaylistConfig = pl
        self.orientation = config.draw_screen.type
        self.deviceIdToPlay = pl.device_id
        var areas = []
        self.playListValidAreasByKey = {}
        _.forEach(config.draw_screen.areas, function (val, key) {
          if (val.type != '') {
            if (val.visible) {
              // we're using the sync with widgets feature... if we dont have a websocket
              // configured, we'll connect to the public one
              if (
                val.type == 'slideshow' &&
                val.config.hasOwnProperty('sync_with_widgets') &&
                val.config.sync_with_widgets * 1 == 1 &&
                !self.kioskIp
              ) {
                self.kioskIp = 'websocket.opalaconsult.com'
                self.kioskToken = self.generateUUID()
                self.webSocketConnect()
              }
              self.$set(self.playListValidAreasByKey, configKey + '#' + key, 1)
              val['areaKey'] = key
              val['configKey'] = configKey
              areas.push(val)
            }
          }
        })
        self.playlistPrevious = pl.device_id + '#' + pl.name
        self.areas = areas
        // console.log('areas', self.areas)
        if (pl.max_duration > 0) {
          clearTimeout(self.timeoutMaxDuration)
          self.timeoutMaxDuration = setTimeout(function () {
            var curidx = self.playlistIdx
            var curDeviceId =  self.playlists[curidx].device_id
            var nextidx = curidx + 1
            if (nextidx > self.playlists.length - 1) nextidx = 0
            for (var i = nextidx; i < self.playlists.length; i++) {
              if (self.playlists[i].device_id != curDeviceId) {
                self.playlistIdx = i
                self.playPlaylist(self.playlists[i])
                break
              }
            }
            // self.playlistIdx = self.playlistIdx + 1
            // console.log('playlistIdx', self.playlistIdx)
            // console.log('self.playlists', self.playlists)
            // console.log('self.playlists111', self.playlists[curidx])
            // self.playPlaylist(self.playlists[self.playlistIdx])
          }, pl.max_duration * 1000)
        }
        // make components start again
        // if (self.playlists.length > 1) {
        self.playlistRestart = !self.playlistRestart
        // }

        if (self.playlists.length > 1 && pl.config.draw_screen.timeout != '' && pl.config.draw_screen.timeout != '0') {
          clearTimeout(self.timeoutPlaylistTimeout)
          self.timeoutPlaylistTimeout = setTimeout(function () {
            if (!pl.config.draw_screen.screen_to) {
              var curidx = self.playlistIdx
              var nextidx = curidx + 1
              if (nextidx > self.playlists.length - 1) nextidx = 0
              self.playlistIdx = nextidx
              self.playPlaylist(self.playlists[nextidx])
            } else {
              var found = false
              _.forEach(self.playlists, function (el, key) {
                if (el.device_id == self.deviceIdToPlay) {
                  if (el.config.draw_screen.description == pl.config.draw_screen.screen_to) {
                    found = true
                    self.playlistIdx = key
                    self.playPlaylist(self.playlists[key])
                  }
                }
              })
              if (!found) {
                var prefix = 'Device'
                if (pl.is_emission) {
                  prefix = 'Emission'
                }
                self.debug(prefix + ' - ' + self.deviceIdToPlay + ' - ' + pl.config.draw_screen.description + ' - Screen to not found - ' + pl.config.draw_screen.screen_to)
              }
            }
          }, (pl.config.draw_screen.timeout * 1) * 1000)
        } else {
          clearTimeout(self.timeoutPlaylistTimeout)
        }
      },
      showConfigError: function (msg) {
        var self = this
        if (typeof msg == 'string') {
          self.error = msg
        } else {
          self.error = JSON.stringify(msg)
        }
      },
      queryParam: function(name) {
        name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]')
        var regex = new RegExp('[\\?&]' + name + '=([^&#]*)')
        var results = regex.exec(window.location.search)
        return results == null ? '' : decodeURIComponent(results[1].replace(/\+/g, ' '))
      },
      getDeviceId: function () {
        var self = this

        // tries to get a device_id from the URL
        var url_device_id = self.queryParam('device_id')
        // var kiosk_ip = self.queryParam('kiosk_ip')
        // var websocket_token = self.queryParam('websocket_token')

        if (url_device_id) {
          self.deviceId = url_device_id
        } else {
          /* self.debug('tvBrand: ' + self.tvBrand)
          self.debug('tvModelName: ' + self.tvModelName)
          self.debug('tvFirmwareVersion: ' + self.tvFirmwareVersion)
          self.debug('tvUHD: ' + self.tvUHD)
          self.debug('tvSdkVersion: ' + self.tvSdkVersion)
          self.debug('macEthernet: ' + self.macEthernet)
          self.debug('macWifi: ' + self.macWifi) */
          if (self.macWifi) {
            self.deviceId = self.macWifi
          } else if (self.macEthernet) {
            self.deviceId = self.macEthernet
          }
        }

        // this div is used to make the screen blink, make it fullscreen
        var attentionDiv = self.$refs['attention']
        attentionDiv.setAttribute('style','width: ' + window.screen.width + 'px; height: ' + window.screen.height + 'px;')

        var shortDeviceId = self.deviceId.substr(0, 3) + self.deviceId.substr(self.deviceId.length - 3, self.deviceId.length)
        self.debug(self.deviceId + ' - ' + shortDeviceId + ' - ' + window.screen.width + 'x' + window.screen.height)
      },
      setupGlobalPlaylist: function (fullCfg) {
        var self = this
        // self.debug('setupGlobalPlaylist')
        // console.log('!!! setupGlobalPlaylist !!!')

        var finalArray = []
        var playlist = self.getPlaylist(fullCfg)
        // console.log('playlist', playlist)
        if (fullCfg.hasOwnProperty('emissions')) {
          // console.log('fullCfg.emissions', fullCfg.emissions)
          fullCfg.emissions = _.sortBy(fullCfg.emissions, ['urgent', 'priority']).reverse()
          _.forEach(fullCfg.emissions, function (emissioncfg, key) {
            if (emissioncfg.hasOwnProperty('device_emission_schedule')) {
              if (!emissioncfg.device_emission_schedule.dates) emissioncfg.device_emission_schedule.dates = []
              if (!emissioncfg.device_emission_schedule.times) emissioncfg.device_emission_schedule.times = []
              if (!emissioncfg.device_emission_schedule.weekDays) emissioncfg.device_emission_schedule.weekDays = []
              var payload = {
                dates: emissioncfg.device_emission_schedule.dates,
                times: emissioncfg.device_emission_schedule.times,
                week_days: emissioncfg.device_emission_schedule.weekDays
              }
              if (!self.checkShow(payload)) {
                return true
              }
            }
            var playlist = self.getPlaylist(emissioncfg)
            _.forEach(playlist, function (el, emissionkey) {
              if (self.playlistHasAreas(el)) {
                finalArray.push({
                  device_id: emissioncfg.device_uid,
                  name: el.name,
                  config: el.config,
                  user_uuid_widget: el.user_uuid_widget,
                  urgent: emissioncfg.urgent || 0,
                  max_duration: emissioncfg.max_duration || 0,
                  priority: emissioncfg.priority || 0,
                  is_emission: true
                })
              }
            })
          })
        }

        _.forEach(playlist, function (el, drawscreenkey) {
          if (self.playlistHasAreas(el)) {
            finalArray.push({
              device_id: fullCfg.device_uid,
              name: el.name,
              config: el.config,
              user_uuid_widget: el.user_uuid_widget,
              urgent: 0,
              priority: 0,
              is_emission: false
            })
          }
        })

        self.validPlaylists = []

        // validate schedules in playlists
        _.forEach(finalArray, function (el) {
          // console.log('finalArray', finalArray)
          if (!el.config.draw_screen.dates) el.config.draw_screen.dates = []
          if (!el.config.draw_screen.times) el.config.draw_screen.times = []
          if (!el.config.draw_screen.week_days) el.config.draw_screen.week_days = []
          var payload = {
            dates: el.config.draw_screen.dates,
            times: el.config.draw_screen.times,
            week_days: el.config.draw_screen.week_days
          }
          if (self.checkShow(payload)) {
            self.validPlaylists.push(el)
          }
        })

        var hasSlideshowOrAudios = false
        var hasSlideshowOrAudiosOnly = true

        // this will be used to prepare contents for the entire playlist
        for (var i = 0; i < self.validPlaylists.length; i++) {
          var p = self.validPlaylists[i]
          var dev_id = p.device_id
          var areas = p.config.draw_screen.areas
          _.forEach(areas, function (v, k) {
            if (v.type == '') return
            var key = dev_id + '#' + p.name + '#' + k

            _.omit(self.areaFiles, [key])
            _.omit(self.playlistsCacheControl, [key])

            // lets get area files
            if (v.type == 'slideshow' || v.type == 'audio') {
              hasSlideshowOrAudios = true
              var screenConfig = p
              var areaConfig = v
              var configKey = p.name
              var areaKey = k

              self.getAreaFiles(screenConfig, dev_id, configKey, areaKey).then(function (files) {
                // we use this vbl to have the original list of area files so we can
                // pre download on the slideshow
                self.$set(self.areaFilesNoFilters, key, [])

                // lets remove inactive files from the array
                var filesVisible = _.filter(files, function (el) {
                  // return id != id
                  if (el.indexOf('-PENDING-.') != -1) {
                    return false
                  } else {
                    self.areaFilesNoFilters[key].push(el)
                    return true
                  }
                })

                // console.log('filesVisible', filesVisible)

                // lets process content schedules
                if (filesVisible.length > 0 && areaConfig.hasOwnProperty('scheduled_contents')) {
                  var contents = self.processContentSchedules(areaConfig, filesVisible)
                  // if (contents.length != filesVisible.length) {
                  filesVisible = contents
                  // }
                }

                // lets process content schedules
                if (filesVisible.length > 0 && areaConfig.hasOwnProperty('labeled_contents')) {
                  var contents = self.processContentLabels(fullCfg, areaConfig, filesVisible)
                  // if (contents.length != filesVisible.length) {
                  filesVisible = contents
                  // }
                }

                if (filesVisible.length > 0) {
                  self.$set(self.areaFiles, key, filesVisible)
                  self.$set(self.playlistsCacheControl, key, 1)
                }
              })
            } else {
              hasSlideshowOrAudiosOnly = false
            }
          })
        }
        // console.log('validPlaylists', self.validPlaylists)
        if (!self.validPlaylists.length) {
          self.debug('No valid playlists found... check schedules and other flags...')
        } else {
          // we've no slideshows, we need to startPlayProcess manually
          if (hasSlideshowOrAudios == false || hasSlideshowOrAudiosOnly == false) {
            self.startPlayProcess()
          } else {
            // we need this timeout for vue reactivity to work
            // setTimeout(function () {
              // console.log('areaFiles', self.areaFiles)
              // self.debug('areaFiles - ' + JSON.stringify(self.areaFiles))
              self.setupGlobalPlaylistTrigger = !self.setupGlobalPlaylistTrigger
            // }, 100)
          }
        }
      },
      startPlayProcess: function () {
        var self = this
        // console.error('startPlayProcess')
        clearTimeout(self.timeoutStartPlayProcess)
        self.timeoutStartPlayProcess = setTimeout(function () {
          var control = ''
          var emptyPlaylists = {}
          // lets remove playlists that have only a slideshow or audio area
          // and dont have contents
          for (var i=0; i<self.validPlaylists.length; i++) {
            var p = self.validPlaylists[i]
            var dev_id = p.device_id
            var areas = p.config.draw_screen.areas
            var slideshowOnly = true
            var hasContents = false
            _.forEach(areas, function(v, k) {
              if (v.type == '') return
              if (!v.visible) return
              if (v.type != 'slideshow' && v.type != 'audio') {
                slideshowOnly = false
                return
              }
              var key = dev_id + '#' + p.name + '#' + k
              if (self.areaFiles.hasOwnProperty(key)) {
                var areaFiles = self.areaFiles[key]
                if (Object.keys(areaFiles).length > 0) hasContents = true
              }
            })
            if (slideshowOnly && !hasContents) {
              emptyPlaylists[i] = 1
            }
          }

          // the playlists that are only a slideshow with no contents will be
          // removed from the global playlist
          if (Object.keys(emptyPlaylists).length > 0) {
            var newPlaylists = []

            for (var i=0; i<self.validPlaylists.length; i++) {
              if (!emptyPlaylists.hasOwnProperty(i)) {
                newPlaylists.push(self.validPlaylists[i])
              }
            }

            self.validPlaylists = newPlaylists
          }

          _.forEach(self.validPlaylists, function (el, key) {
            control = control + el.device_id + '#' + el.name + ','
          })

          if (control != self.playlistChangeControl) {
            self.playlistChangeControl = control
            self.playlists = self.validPlaylists

            if (self.queryParam('from_backoffice') == 1) {
              _.forEach(self.playlists, function (val) {
                var found = false
                _.forEach(val.config.draw_screen.areas, function (val, key) {
                  if (val.type != '') {
                    if (val.visible && val.type == 'slideshow') {
                      var playSound = val.config.play_sound || 0
                      if (playSound) {
                        self.debug('Click on the screen or else sound wont work...', 'orange')
                        found = true
                        return false
                      }
                    }
                  }
                })
                if (found) return false
              })
            }
            self.playPlaylist(self.playlists[0])
          }

          if (self.playlists.length == 0)  {
            var aux = ''
            if (self.auxDeviceId) aux = ' <span style="font-size: 15px;">aux_device_id - #' + self.auxDeviceId + '#</span>'
            self.showError('No contents' + aux + '<br>' + self.deviceId)
          } else {
            self.emptyContents = ''
          }
        }, 500)
      },
      processContentLabels: function (deviceConfig, curAreaConfig, files) {
        var self = this
        var finalContents = []
        var labeledContents = curAreaConfig['labeled_contents'] || {}
        var labelsValid = {}

        // console.log('processContentLabels - start', files.length)

        if (deviceConfig.hasOwnProperty('labels_valid')) labelsValid = deviceConfig['labels_valid']

        if (Object.keys(labelsValid).length == 0) {
          // console.log('error1')
          return files
        }

        var deviceLabelsTmp = deviceConfig.config.labels || {}
        if (Object.keys(deviceLabelsTmp).length == 0) {
          // console.log('error2')
          return files
        }

        var deviceLabels = {}
        // device has labels defined, lets validate them
        _.forEach(deviceLabelsTmp, function (el, key) {
          if (labelsValid.hasOwnProperty(key)) deviceLabels[key] = el
        })

        if (Object.keys(deviceLabels).length == 0) {
          // console.log('error3')
          return files
        }

        // this object also has the label scheduling
        // lets validate labels schedule
        var deviceLabelsAfterSchedule = {}

        _.forEach(deviceLabels, function (el, key) {
          var schedule = labelsValid[key]
          if (schedule) {
            var ref = JSON.parse(schedule)
            if (!ref.dates) ref.dates = []
            if (!ref.times) ref.times = []
            if (!ref.weekDays) ref.weekDays = []
            var payload = {
              dates: ref.dates,
              times: ref.times,
              week_days: ref.weekDays
            }
            if (self.checkShow(payload)) {
              deviceLabelsAfterSchedule[key] = el
            }
          }
        })

        deviceLabels = deviceLabelsAfterSchedule

        // no labels valid, return only the contents that have no labels on them
        if (Object.keys(deviceLabels).length == 0) {
          _.forEach(files, function (file, idx) {
            var fileWoIdx = file.split('_').slice(1).join('_')
            if (!labeledContents.hasOwnProperty(fileWoIdx)) {
              finalContents.push(file)
            }
          })
          return finalContents
        }

        _.forEach(files, function (file, idx) {
          var fileWoIdx = file.split('_').slice(1).join('_')
          // content is not labeled, use it
          if (!labeledContents.hasOwnProperty(fileWoIdx)) {
            finalContents.push(file)
          } else {
            var fileLabels = labeledContents[fileWoIdx].labels_selected
            var validsFound = {}
            _.forEach(fileLabels, function (el, key) {
              if (deviceLabels.hasOwnProperty(key)) {
                validsFound[file] = 1
              }
            })
            if (validsFound.hasOwnProperty(file)) finalContents.push(file)
          }
        })

        // console.log('processContentLabels - end', finalContents.length)
        return finalContents
      },
      processContentSchedules: function (curAreaConfig, files) {
        var self = this
        var finalContents = []
        // console.log('processContentSchedules - start', files.length)
        var scheduledContents = curAreaConfig['scheduled_contents'] || {}
        _.forEach(files, function (file) {
          var fileWoIdx = file.split('_').slice(1).join('_')
          if (!scheduledContents.hasOwnProperty(fileWoIdx)) {
            finalContents.push(file)
          } else {
            var ref = scheduledContents[fileWoIdx]
            if (ref) {
              if (!ref.dates) ref.dates = []
              if (!ref.times) ref.times = []
              if (!ref.weekDays) ref.weekDays = []
              var payload = {
                dates: ref.dates,
                times: ref.times,
                week_days: ref.weekDays
              }
              // console.log('PAYLOAD', payload)
              if (self.checkShow(payload)) {
                finalContents.push(file)
              }
            }
          }
        })

        // console.log('processContentSchedules - end', finalContents.length)
        return finalContents
      },
      getAreaFiles: function (cfg, deviceId, configKey, areaKey) {
        var self = this
        // self.debug('getAreaFiles')
        return new Promise(function (resolve, reject) {
          var key = 'area_files#' + deviceId + '#' + configKey + '#' + areaKey
          if (!self.contentsChanged) {
            self.db.getItem(key).then(function (cfg) {
              if (cfg) {
                var ref = JSON.parse(cfg)
                if (!ref.error) {
                  // console.log('FILES - aqui1', key, ref.files)
                  resolve(ref.files)
                } else {
                  reject([])
                }
              } else {
                self.getAreaFilesFromNet(cfg, deviceId, configKey, areaKey).then(function (files) {
                  resolve(files)
                })
              }
            })
          } else {
            if (self.areaFiles.hasOwnProperty(key)) {
              // console.log('FILES - aqui2', key, self.areaFiles[key])
              resolve(self.areaFiles[key])
            } else {
              self.getAreaFilesFromNet(cfg, deviceId, configKey, areaKey).then(function (files) {
                resolve(files)
              })
            }
          }
        })
      },
      getAreaFilesFromNet: function (cfg, deviceId, configKey, areaKey) {
        var self = this
        // self.debug('getAreaFilesFromNet')
        return new Promise(function (resolve, reject) {
          var key = 'area_files#' + deviceId + '#' + configKey + '#' + areaKey
          var url = self.http_method + self.apiUrl + '/get_area_files?device_id=' + deviceId + '&config_key=' + configKey + '&area_key=' + areaKey + '&complement=/slideshow'
          if (self.isLocalhost) {
            url = _.replace(url, 'apis.opalaconsult.com', '127.0.0.1')
          }
          var xhr = new XMLHttpRequest()
          xhr.onerror = function () {
            self.db.getItem(key).then(function (cfg) {
              if (cfg) {
                var ref = JSON.parse(cfg)
                if (!ref.error) {
                  // console.log('FILES - aqui3', key, ref.files)
                  resolve(ref.files)
                } else {
                  reject([])
                }
              }
            }).catch(function (err) {
              reject([])
            })
          }
          xhr.onreadystatechange = function () {
            if (xhr.readyState == XMLHttpRequest.DONE) {
              if (xhr.status == 200) {
                var ref = JSON.parse(xhr.responseText)
                if (!ref.error) {
                  self.db.setItem(key, xhr.responseText).then(function (data) {
                    // console.log('FILES - aqui4', key, ref.files)
                    resolve(ref.files)
                  }).catch(function (err) {
                    reject([])
                  })
                }
              }
            }
          }
          xhr.open('GET', url)
          xhr.send()
        })
      },
      checkShow: function (payload) {
        var self = this
        var validWeekDays = null
        var validDates = null
        var validTimes = null
        // console.log('PAYLOAD', payload)
        if (
          payload.week_days.length == 0 &&
          payload.dates.length == 0 &&
          payload.times.length == 0
        ) return false

        if (payload.week_days && payload.week_days.length) {
          validWeekDays = self.checkWeekDays(payload)
        }
        if (payload.dates && payload.dates.length) {
          validDates = self.checkDates(payload)
        }
        if (payload.times && payload.times.length) {
          validTimes = self.checkTimes(payload)
        }

        var finalReturn = false
        if (!validWeekDays && !validDates && !validTimes) return finalReturn
        var check = [validWeekDays, validDates, validTimes]

        for (var key in check) {
          var item = check[key]
          if (item == false) {
            return false
          } else if (item) {
            finalReturn = true
          }
        }
        return finalReturn
      },
      dateStrToObject: function (dateString) {
        // Parse the date string
        var dateParts = dateString.split(' ')
        var datePart = dateParts[0]
        var timePart = dateParts[1]
        var dateComponents = datePart.split('-')
        var timeComponents = timePart.split(':')
        var year = parseInt(dateComponents[0], 10)
        var month = parseInt(dateComponents[1], 10) - 1
        var day = parseInt(dateComponents[2], 10)
        var hours = parseInt(timeComponents[0], 10)
        var minutes = parseInt(timeComponents[1], 10)
        var seconds = parseInt(timeComponents[2], 10)
        var date = new Date(year, month, day, hours, minutes, seconds)
        return date
      },
      checkWeekDays: function (payload) {
        var self = this
        var check = (payload.week_days.indexOf(self.curDate.getDay()) != -1)
        return check
      },
      checkDates: function (payload) {
        var self = this
        var today = dateFormat(self.curDate, 'yyyy-mm-dd')
        var next = false
        for (var d in payload.dates) {
          var myDate = payload.dates[d]
          if (today >= myDate.from && today <= myDate.to) {
            next = true
            break
          }
        }
        return next
      },
      checkTimes: function (payload) {
        var self = this
        var now = dateFormat(self.curDate, 'HH:MM')
        // console.log('checkTimes', now)
        var next = false

        for (var t in payload.times) {
          var time = payload.times[t]
          if (now >= time.from && now <= time.to) {
            next = true
            break
          }
        }
        return next
      },
      getPlaylist: function (deviceConfig) {
        var self = this
        var playlist = []
        var userUuidWidget = ''
        if (deviceConfig.config.hasOwnProperty('user_uuid_widget')) {
          userUuidWidget = deviceConfig.config['user_uuid_widget']
        }
        _.forEach(deviceConfig.config, function (devicecfg, devicecfgkey) {
          if (devicecfgkey.indexOf('config_')!= -1) {
            playlist.push({
              name: devicecfgkey,
              config: devicecfg,
              user_uuid_widget: userUuidWidget
            })
          }
        })
        return playlist
      },
      playlistHasAreas: function (playlist) {
        var self = this
        var ret = false
        _.forEach(playlist.config.draw_screen.areas, function (area, areakey){
          if (area.type && area.visible) {
            ret = true
            return false
          }
        })
        return ret
      },
      getDeviceConfig: function () {
        var self = this
        // self.debug('getDeviceConfig - ' + self.hasInternet)
        if (! self.hasInternet) {
          // lets try to load a previously saved config
          self.db.getItem('miravision_config').then(function(cfg) {
            if (cfg) {
              var ref = JSON.parse(cfg)
              if (!ref.error) {
                self.playConfig(ref)
              }
            } else {
              self.showError('No config found (1)' + '<br>' + self.deviceId)
              // self.showConfigError('getDeviceConfig - couldnt get device config from cache - ' + self.deviceId)
            }
            // console.log('SAVED CFG', cfg)
          }).catch(function (err) {
            self.showError('No config found (2)' + '<br>' + self.deviceId)
            // self.showConfigError('getDeviceConfig - couldnt get device config from cache - ' + self.deviceId)
          })
        } else {
          var url = self.http_method + self.apiUrl + '/get_screen_play_config_noencode?device_id=' + self.deviceId + '&store_fo_id=' + self.storeFoId + '&install_token=' + self.installToken

          var xhr = new XMLHttpRequest()
          xhr.onerror = function () {
            console.log('error in get_screen_play_config, lets use a config saved before...')
            // lets try to load a previously saved config
            self.db.getItem('miravision_config').then(function(cfg) {
              if (cfg) {
                var ref = JSON.parse(cfg)
                if (!ref.error) {
                  self.playConfig(ref)
                }
              } else {
                // self.showConfigError('getDeviceConfig - couldnt get device config from cache - ' + self.deviceId)
                self.showError('No config found (3)' + '<br>' + self.deviceId)
              }
              // console.log('SAVED CFG', cfg)
            }).catch(function (err) {
              // self.showConfigError('getDeviceConfig - couldnt get device config from cache - ' + self.deviceId)
              self.showError('No config found (4)' + '<br>' + self.deviceId)
            })
          }
          xhr.onreadystatechange = function () {
            if (xhr.readyState == XMLHttpRequest.DONE) {
              if (xhr.status == 200) {
                var ref = JSON.parse(xhr.responseText)
                if (ref.hasOwnProperty('config')) {
                  if (Object.keys(ref.config).length == 0) {
                    var aux = ''
                    if (self.storeFoId) aux = ' <span style="font-size: 15px;">aux_device_id - ' + self.auxDeviceId + '</span>'
                    self.showError('Device not configured' + aux + '<br>' + self.deviceId)
                    return
                  }
                }
                if (ref.error) {
                  if (self.hasInternet) self.registerDevice()
                  var aux = ''
                  if (self.storeFoId) aux = ' <span style="font-size: 15px;">aux_device_id - ' + self.auxDeviceId + '</span>'
                  self.showError('Device not configured' + aux + '<br>' + self.deviceId)
                } else {
                  self.db.setItem('miravision_config', xhr.responseText).then(function() {
                    // success
                    self.playConfig(ref)
                  }).catch(function(err) {
                    // This code runs if there were any errors
                    self.debug('FAILED STORING miravision_config - ' + err.message)
                  })
                }
              }
            }
          }
          xhr.open('GET', url)
          xhr.send()
        }
      },
      showError: function (msg) {
        var self = this
        // do a window focus to start catching key presses
        window.focus()
        self.emptyContents = msg
        setTimeout(function () {
          if (self.$refs.store_fo_id_div.style.display != 'block') {
            location.reload()
          }
        }, 10000)
      },
      playConfig: function (ref) {
        var self = this
        // console.log('playConfig', ref)
        // self.debug('playConfig')
        if (self.$refs.store_fo_id_div.style.display == 'block') return
        if (self.hasInternet) self.registerDevice()

        self.deviceConfig = ref

        if (self.deviceConfig.hour_adjust) self.hourAdjust = self.deviceConfig.hour_adjust

        if (self.hourAdjust != 0) {
          if (self.hourAdjust < 0) {
            // console.log('subtract')
            self.curDate.setHours(self.curDate.getHours() - Math.abs(self.hourAdjust));
          } else {
            // console.log('add')
            self.curDate.setHours(self.curDate.getHours() + Math.abs(self.hourAdjust));
          }
        }

        self.setScreenBrightness()

        if (self.deviceConfig.config.ip_screen) {
          self.kioskIp = self.deviceConfig.config.ip_screen
          self.kioskToken = self.deviceConfig.config.websocket_token || ''
          self.webSocketConnect()
        }

        var previousConfigMd5 = ''
        var currentConfigMd5 = ''
        self.contentsChanged = false

        // do a window focus to start catching key presses
        window.focus()

        self.db.getItem('miravision_config_md5').then(function(md5) {
          if (md5) {
            previousConfigMd5 = md5
          }
          // self config md5 plus all emissions md5s
          currentConfigMd5 = self.deviceConfig.md5_config + '#' + self.deviceConfig.contents_md5 + '#'
          if (self.deviceConfig.hasOwnProperty('emissions')) {
            _.forEach(self.deviceConfig.emissions, function(el) {
              currentConfigMd5 = currentConfigMd5 + el.contents_md5 + '#'
            })
          }

          // console.error('previousConfigMd5', previousConfigMd5)
          // console.error('currentConfigMd5', currentConfigMd5)

          if (previousConfigMd5 != currentConfigMd5) {
            self.contentsChanged = true
            self.db.setItem('miravision_config_md5', currentConfigMd5)
          }

          // used to control if we need to sync datetime between devices
          if (!self.deviceConfig.hasOwnProperty('devices_together')) {
            self.deviceConfig.devices_together = 0
          }
          // console.log(self.deviceConfig)
          self.bgColor = 'rgba(0,0,0,1)'

          if (self.deviceConfig.config.bg_color) self.bgColor = self.deviceConfig.config.bg_color
          if (self.deviceConfig.config.websocket_token) self.kioskToken = self.deviceConfig.config.websocket_token

          self.setupGlobalPlaylist(self.deviceConfig)

          clearInterval(self.timerSetupGlobalPlaylist)
          self.timerSetupGlobalPlaylist = setInterval(function () {
            var second = self.curDate.getSeconds()
            if (second == 0) {
              self.setupGlobalPlaylist(self.deviceConfig)
            }
          }, 1000)

          // we have a reload timer defined
          if (parseInt(self.deviceConfig.config.reload_timer) > 0) {
            setTimeout(function () {
              location.reload()
            }, parseInt(self.deviceConfig.config.reload_timer) * 1000)
          }
        })
      },
      registerDevice: function () {
        var self = this
        var data = new FormData()
        data.append('type', 'screen')
        data.append('device_id', self.deviceId)
        data.append('tv_brand', self.tvBrand)
        data.append('tv_firmware_version', self.tvFirmwareVersion)
        data.append('tv_sdk_version', self.tvSdkVersion)
        data.append('tv_uhd', self.tvUHD)
        data.append('tv_model_name', self.tvModelName)
        data.append('tv_device_id', self.deviceId)
        data.append('tv_mac_ethernet', self.macEthernet)
        data.append('tv_mac_wifi', self.macWifi)

        var xhr = new XMLHttpRequest()
        xhr.open('POST', self.http_method + self.apiUrl + '/device_get_v2')
        xhr.send(data)
      },
      getFactorUnit: function (cfg) {
        var self = this
        var orientation = cfg.draw_screen.type
        var screen = document.getElementById('my_screen')
        screen.style.width = window.innerWidth + 'px'
        screen.style.height = window.innerHeight + 'px'
        self.screenWidth = screen.offsetWidth
        self.screenHeight = screen.offsetHeight

         // HORIZONTAL SCREEN
        if (orientation == 'horizontal') {
          self.factor_width = self.screenWidth / self.baseWidth
          self.factor_height = self.screenHeight / self.baseHeight
        } else {
          // VERTICAL SCREEN
          self.factor_width = self.screenWidth / self.baseWidthVertical
          self.factor_height = self.screenHeight / self.baseHeightVertical
        }
        // console.log('FACTOR', self.factor_width, self.factor_height)
      },
      webSocketConfigConnect: function () {
        var self = this
        self.wsConfig = new WebSocket(self.ws_method + 'websocket.opalaconsult.com/websocket')

        self.wsConfig.onopen = function () {
          // self.debug.push('wsConfig.onopen')
          console.log('wsConfig.onopen')
          // gives time for other componets to load before changing state
          setTimeout(function () {
            self.wsConfigConnected = true
          }, 1000)
          // self.wsConfigSend('slideshow_restart', { 'store_uid': self.deviceConfig.store_uid })
        }

        self.wsConfig.onclose = function (e) {
          // self.debug.push('wsConfig.onclose')
          self.wsConfigConnected = false
          console.log('wsConfig.onclose', e.reason)
          // if connection goes down, tries to connect again in 5 secs
          setTimeout(function () {
            self.webSocketConfigConnect()
          }, 1000)
        }

        self.wsConfig.onerror = function (e) {
          self.wsConfigConnected = false
          // self.debug.push('wsConfig.onerror')
          console.log('wsConfig.onerror', e)
          self.wsConfig.close()
        }

        self.wsConfig.onmessage = function (msg) {
          var res = JSON.parse(msg.data) || {}
          // this will make slideshow to restart and keep slideshow devices in sync
          if (res.hasOwnProperty('action')) {
            if (res.action == 'slideshow_restart') {
              // self.debug(res.action)
              var tag = res.params.tag || ''
              // self.debug('self.wsConfig.onmessage - ' + tag)
              if (tag) {
                // self.debug('slideshow_restart!!! - ' + tag)
                self.slideshowSync = tag
                self.slideshowSyncTrigger = !self.slideshowSyncTrigger
              }
            }
          }
          // datetime set that came from websocket as soon as we connect to websocket server
          if (!self.receivedDateFromWebsocket && res.hasOwnProperty('datetime_epoch')) {
            self.curDate = new Date(self.dateStrToObject(res.datetime_str)) // keep date updated

            if (self.hourAdjust != 0) {
              if (self.hourAdjust < 0) {
                // console.log('subtract')
                self.curDate.setHours(self.curDate.getHours() - Math.abs(self.hourAdjust));
              } else {
                // console.log('add')
                self.curDate.setHours(self.curDate.getHours() + Math.abs(self.hourAdjust));
              }
            }

            self.receivedDateFromWebsocket = true
            // self.debug('date adjust 1 ' + res.datetime_str + ' - ' + self.curDate)
            return
          }

          // if we receive other thing thats not a config_update, we return
          if (res.device_id != self.deviceId || res.origin != 'browser' || res.action != 'config_update') return

          if (res.hasOwnProperty('params')) {
            var screenshot = res.params.screenshot || 0
            var isOnline = res.params.is_online || 0
            var fromBackoffice = self.queryParam('from_backoffice') || 0
            if (screenshot * 1 == 1) {
              console.log('take screenshot!')
              self.takeScreenshot()
            }
            else if (parseInt(isOnline) == 1 || parseInt(fromBackoffice) == 1) {
              location.reload()
            }
          } else {
            // location.reload()
          }
        }
      },
      toggleBlinking: function (el) {
        var self = this
        self.blinkCount++
        if (el.style.display == 'block') {
          // console.log('hide - ' + el.style.display, el)
          el.style.display = 'none'
          if (self.blinkCount >= 10) {
            self.blinkCount = 0
            clearInterval(self.timerBlink)
          }
        } else {
          // console.log('show - ' + el.style.display, el)
          el.style.display = 'block'
        }
      },
      webSocketConnect: function () {
        var self = this

        if (! self.kioskIp) return
        self.ws = new WebSocket(self.ws_method + self.kioskIp + '/websocket')

        self.ws.onopen = function () {
          // self.debug.push('ws.onopen')
          console.log('ws.onopen')
          // gives time for other componets to load before changing state
          setTimeout(function () {
            self.wsConnected = true
          }, 1000)
        }

        self.ws.onclose = function (e) {
          // self.debug.push('ws.onclose')
          self.wsConnected = false
          console.log('ws.onclose', e.reason)
          // if connection goes down, tries to connect again in 5 secs
          setTimeout(function () {
            self.webSocketConnect()
          }, 1000)
        }

        self.ws.onerror = function (e) {
          self.wsConnected = false
          // self.debug.push('ws.onerror')
          console.log('ws.onerror', e)
          self.ws.close()
        }

        self.ws.onmessage = function (msg) {
          var res
          try {
            res = JSON.parse(msg.data) || {}
          } catch (error) {
          }
          if (!res) return
          // validate token if a token is being used
          if (self.kioskToken && res.websocket_token != self.kioskToken) return
          if (res.target_device_id && res.target_device_id != self.deviceId) return
          self.wsMessage = res

          var action = res.action || ''
          // console.log('res', res)
          switch (res.action) {
            case 'sound_play':
              var sound = res.sound || ''
              if (! sound) {
                console.error('Missing sound parameter...')
                return
              }
              self.playSounds(sound, self.kioskIp)
              break
            case 'blink_screen':
              //
              var color = res.color || ''
              var attentionDiv = self.$refs['attention']
              if (color) {
                // myDiv.style.backgroundColor = 'rgba(255, 0, 0, 0.5)';
                attentionDiv.style.backgroundColor = color;
              }
              clearInterval(self.timerBlink)
              self.timerBlink = setInterval(function () {
                self.toggleBlinking(attentionDiv)
              }, 400)
              break
            default:
              // default action
          }
        }
      },
      deleteInterval: function (id) {
        var self = this
        clearInterval(id)
        self.intervals = _.filter(self.intervals, function (id) {
          return id != id
        })
        // console.log('intervals delete', self.intervals)
      },
      createInterval: function (func, timeout) {
        var self = this
        var interval = setInterval(func, timeout)
        self.intervals.push(interval)
        // console.log('intervals create', self.intervals)
        return interval
      },
      createTimeout: function (func, timeout) {
        var self = this
        var timeout = setTimeout(func, timeout)
        self.timeouts.push(timeout)
        // console.log('timeouts create', self.timeouts)
        return timeout
      }
    }
  })

  // -----------------------------------------------------------------------
  // END MAIN CODE
  // -----------------------------------------------------------------------
}
