// -----------------------------------------------------------------------
// COMPONENT - MARQUEE
// -----------------------------------------------------------------------
Vue.component('my-marquee', {
  props: {
    area: {
      type: Object
    },
    parent: {
      type: Object
    },
    device_id: {
      type: String
    },
    factor_width: {
      type: Number
    },
    factor_height: {
      type: Number
    }
  },
  data: function () {
    return {
      fontFactor: 15,
      text: '',
      rssNews: [],
      scrollSpeed: 6,
      loop: 1,
      height_parent: 0,
      height: 0
    }
  },
  created: function () {
    var self = this
  },
  mounted: function () {
    var self = this
    self.setup()
  },
  computed: {
    genNews: function () {
      var self = this
      var res
      var str = ''
      var desc = self.area.config.rss_fields
      _.forEach(self.rssNews, function (value, idx) {
        str = str + value[desc] + ' ● '
      })
      if (str) {
        res = self.text + ' ● ' + str
      } else {
        res = self.text
      }
      return res
    }
  },
  methods: {
    setup: function () {
      var self = this
      if (self.area.config.speed) self.scrollSpeed = self.area.config.speed / 3
      if (self.area.config.font_size) self.fontFactor = self.area.config.font_size / 10
      if (self.area.config.title) self.text = self.area.config.title

      self.getNews()

      self.parent.createInterval(function () {
        self.getNews()
      }, 10 * 60 * 1000) // 10 minutes

      setTimeout(function () {
        var main = self.$refs['main']
        self.height = main.clientHeight
        self.height_parent = main.parentElement.parentElement.clientHeight
      }, 100)
    },
    getNews: function () {
      var self = this
      var url = self.parent.http_method + self.parent.apiUrl + '/rss_get?feed=' + self.area.config.rss
      var xhr = new XMLHttpRequest()
      xhr.open('GET', url, false)
      xhr.send()
      // self.debug = xhr.responseText
      if (xhr.status == 200) {
        self.rssNews = []
        var ref = JSON.parse(xhr.responseText)
        if (!ref.error) {
          _.forEach(ref.channel.item, function (value, index) {
            self.rssNews.push(value)
          })
        } else {
          return false
          // self.showConfigError('Erro ao obter configuração 1')
        }
      } else {
        return false
        // self.showConfigError('Erro ao obter configuração 2')
      }
    }
  },
  watch: {
    'parent.playlistRestart': function (res) {
      var self = this
      self.setup()
    }
  },
  template: '<div ref="main" :style="\'margin-top: \' + ((height_parent / 2) - (height / 2)) + \'px;\'"><marquee :scrollamount="scrollSpeed" :style="\'padding-top: 1vh; font-size: \' + (2.5 * fontFactor) + \'vh;\'"><span v-html="genNews"></span></marquee></div>'
})
// -----------------------------------------------------------------------
// END MARQUEE
// -----------------------------------------------------------------------
