// -----------------------------------------------------------------------
// COMPONENT - QRCODE
// -----------------------------------------------------------------------
Vue.component('qrcode', {
  props: {
    area: {
      type: Object
    },
    parent: {
      type: Object
    },
    device_id: {
      type: String
    },
    factor_width: {
      type: Number
    },
    factor_height: {
      type: Number
    }
  },
  data: function () {
    return {
    }
  },
  created: function () {
    var self = this
    // alert('qrcode')
  },
  mounted: function () {
    var self = this
    self.setup()
  },
  computed: {
    width: function () {
      var self = this
      return (self.area.width * self.factor_width) + 'px'
    },
    height: function () {
      var self = this
      return (self.area.height * self.factor_height) + 'px'
    },
    url: function () {
      var self = this
      var origin = self.parent.queryParam('origin') || ''
      var url = self.parent.http_method + self.parent.apiUrl + '/url_open?' +
        'url=' + self.area.config.url + '&device_id=' + self.device_id + '&origin=' + origin
      return url
    }
  },
  methods: {
    setup: function () {
      var self = this
      self.setQrCode()
    },
    setQrCode: function () {
      var self = this
      // console.log('URL', self.url)
      var qrcode = new QRCode("qrcode", {
        text: self.url,
        width: self.width.replace('px', '') * 1,
        height: self.height.replace('px', '') * 1,
        colorDark : "#000000",
        colorLight : "#ffffff",
        correctLevel : QRCode.CorrectLevel.H
      })
      // qrcode.makeCode("http://naver.com")
    }
  },
  watch: {
    'parent.playlistRestart': function (res) {
      var self = this
      self.setup()
    }
  },
  template: '<div>' +
  '<div id="qrcode"></div>' +
  '</div>'
})
// -----------------------------------------------------------------------
// END QRCODE
// -----------------------------------------------------------------------
