let utils_ws = null
let utils_params = {}
let utils_songs_to_play = []
let utils_sound_playing = false
let ws_interval = undefined
let widget_time_obj = ''
let widget_time = ''
let widget_date = ''
let initial_hour = ''
let initial_minute = ''
let initial_second = ''
let widget_current_time = {}

var dateFormat = function () {
	var	token = /d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,
		timezone = /\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,
		timezoneClip = /[^-+\dA-Z]/g,
		pad = function (val, len) {
			val = String(val);
			len = len || 2;
			while (val.length < len) val = "0" + val;
			return val;
		};

	// Regexes and supporting functions are cached through closure
	return function (date, mask, utc) {
		var dF = dateFormat;

		// You can't provide utc if you skip other args (use the "UTC:" mask prefix)
		if (arguments.length == 1 && Object.prototype.toString.call(date) == "[object String]" && !/\d/.test(date)) {
			mask = date;
			date = undefined;
		}

		// Passing date through Date applies Date.parse, if necessary
		date = date ? new Date(date) : new Date;
		if (isNaN(date)) throw SyntaxError("invalid date");

		mask = String(dF.masks[mask] || mask || dF.masks["default"]);

		// Allow setting the utc argument via the mask
		if (mask.slice(0, 4) == "UTC:") {
			mask = mask.slice(4);
			utc = true;
		}

		var	_ = utc ? "getUTC" : "get",
			d = date[_ + "Date"](),
			D = date[_ + "Day"](),
			m = date[_ + "Month"](),
			y = date[_ + "FullYear"](),
			H = date[_ + "Hours"](),
			M = date[_ + "Minutes"](),
			s = date[_ + "Seconds"](),
			L = date[_ + "Milliseconds"](),
			o = utc ? 0 : date.getTimezoneOffset(),
			flags = {
				d:    d,
				dd:   pad(d),
				ddd:  dF.i18n.dayNames[D],
				dddd: dF.i18n.dayNames[D + 7],
				m:    m + 1,
				mm:   pad(m + 1),
				mmm:  dF.i18n.monthNames[m],
				mmmm: dF.i18n.monthNames[m + 12],
				yy:   String(y).slice(2),
				yyyy: y,
				h:    H % 12 || 12,
				hh:   pad(H % 12 || 12),
				H:    H,
				HH:   pad(H),
				M:    M,
				MM:   pad(M),
				s:    s,
				ss:   pad(s),
				l:    pad(L, 3),
				L:    pad(L > 99 ? Math.round(L / 10) : L),
				t:    H < 12 ? "a"  : "p",
				tt:   H < 12 ? "am" : "pm",
				T:    H < 12 ? "A"  : "P",
				TT:   H < 12 ? "AM" : "PM",
				Z:    utc ? "UTC" : (String(date).match(timezone) || [""]).pop().replace(timezoneClip, ""),
				o:    (o > 0 ? "-" : "+") + pad(Math.floor(Math.abs(o) / 60) * 100 + Math.abs(o) % 60, 4),
				S:    ["th", "st", "nd", "rd"][d % 10 > 3 ? 0 : (d % 100 - d % 10 != 10) * d % 10]
			};

		return mask.replace(token, function ($0) {
			return $0 in flags ? flags[$0] : $0.slice(1, $0.length - 1);
		});
	};
}();

// Some common format strings
dateFormat.masks = {
	"default":      "ddd mmm dd yyyy HH:MM:ss",
	shortDate:      "m/d/yy",
	mediumDate:     "mmm d, yyyy",
	longDate:       "mmmm d, yyyy",
	fullDate:       "dddd, mmmm d, yyyy",
	shortTime:      "h:MM TT",
	mediumTime:     "h:MM:ss TT",
	longTime:       "h:MM:ss TT Z",
	isoDate:        "yyyy-mm-dd",
	isoTime:        "HH:MM:ss",
	isoDateTime:    "yyyy-mm-dd'T'HH:MM:ss",
	isoUtcDateTime: "UTC:yyyy-mm-dd'T'HH:MM:ss'Z'"
};

// Internationalization strings
dateFormat.i18n = {
	dayNames: [
		"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat",
		"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"
	],
	monthNames: [
		"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
		"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
	]
};

// For convenience...
Date.prototype.format = function (mask, utc) {
	return dateFormat(this, mask, utc);
};

// get audioContext based of the device type we're at
function starTime (self, format_date, format_time) {
  // console.log('starTime - widget_time: ' + widget_time)
  if (!widget_time) {
    // console.log('WIDGETS JS aqui 1')
    let now = new Date()
    widget_time = now.format('yyyy-mm-dd HH:MM:ss')
  }
  // console.log('WIDGETS JS  aqui 2')
  let myDateTime = widget_time.split(' ')

  if (myDateTime.length > 1) {
    widget_date = myDateTime[0]
    let myTime = myDateTime[1].split(':')
    initial_hour = myTime[0]
    initial_minute = myTime[1]
    initial_second = myTime[2]
    widget_time_obj = new Date()
    widget_time_obj.setHours(initial_hour)
    widget_time_obj.setMinutes(initial_minute)
    widget_time_obj.setSeconds(initial_second)
    startTimeInterval(self, format_date, format_time)
  }
}

function startTimeInterval (self, format_date, format_time) {
  widget_date = formatDate(format_date)
  widget_time = formatTime(format_time)
  setInterval(() => {
    // we did this because screen was loosing time
    // updateTimeFromLocal()
    widget_time_obj.setSeconds((widget_time_obj.getSeconds() * 1) + 1)
    widget_date = formatDate(format_date)
    widget_time = formatTime(format_time)
    self.widget_date = widget_date
    self.widget_time = widget_time
  }, 1000)
}

function updateTimeFromLocal() {
  let now = new Date()
  let secs = now.format('ss')
  // we only do this on second 0
  if (secs != 0) return

  widget_time = now.format('yyyy-mm-dd HH:MM:ss')

  let myDateTime = widget_time.split(' ')

  if (myDateTime.length) {
    widget_date = myDateTime[0]
    let myTime = myDateTime[1].split(':')
    initial_hour = myTime[0]
    initial_minute = myTime[1]
    initial_second = myTime[2]
    widget_time_obj = new Date()
    widget_time_obj.setHours(initial_hour)
    widget_time_obj.setMinutes(initial_minute)
    widget_time_obj.setSeconds(initial_second)
  }
}

function formatDate (format_date) {
  let month = '' + (widget_time_obj.getMonth() + 1)
  let day = '' + widget_time_obj.getDate()
  let year = widget_time_obj.getFullYear()

  if (month.length < 2)
      month = '0' + month;
  if (day.length < 2)
      day = '0' + day;

  let format = format_date.split('-')
  if (format[0] === 'YYYY') {
    return [year, month, day].join('-')
  } else if (format[0] === 'DD') {
    return [day, month, year].join('-')
  } else {
    return ''
  }
}

function formatTime (format_time) {
  let hour = widget_time_obj.getHours()
  let minutes = widget_time_obj.getMinutes()
  let seconds = widget_time_obj.getSeconds()

  if (minutes * 1 < 10) {
    minutes = `0${minutes}`
  }

  if (hour * 1 < 10) {
    hour = `0${hour}`
  }

  if (seconds * 1 < 10) {
    seconds = `0${seconds}`
  }

  let myTime = format_time.split(':')

  if (myTime.length === 2) {
    return `${hour}:${minutes}`
  } else {
    return `${hour}:${minutes}:${seconds}`
  }
}

function getAudioContext (navigator) {
  let ua = navigator.userAgent.toUpperCase()

  // we're on a smarttv
  if (ua.toUpperCase().indexOf('SMARTTV') !== -1) {
    return new webkitAudioContext()
  }
  // any other device
  else {
    let audioContext = new (window.AudioContext || window.webkitAudioContext)()
    return audioContext
  }
}

function loadSound (context, soundUrl) {
  var request = new XMLHttpRequest()
  request.open('GET', soundUrl, true)
  request.responseType = 'arraybuffer'
  //console.log('loadSound - ', soundUrl)
  request.onload = function () {
  if (! request.response || request.response.byteLength < 500) {
    setTimeout( () => {
      console.log('will try to play again...')
      loadSound(context, soundUrl)
      }, 500);
    }
    else {
      //console.log('sound length', request.response.byteLength)
      context.decodeAudioData(request.response, function (buffer) {
      playSound(context, buffer)
      })
    }
  }
  request.send()
}

function playSounds (context, sound, ip_screen) {
  if (sound === 'dingdong' || sound === 1) {
    utils_songs_to_play.push('http://apis.opalaconsult.com/queues_backoffice/sounds/dingdong.mp3')
  } else {
    utils_songs_to_play.push(`http://apis.opalaconsult.com/queues_backoffice/sounds/${sound}.mp3`)
  }
  if (utils_songs_to_play.length && !utils_sound_playing) {
    utils_sound_playing = true
    utils_songs_to_play.unshift(`http://apis.opalaconsult.com/queues_backoffice/sounds/silence.mp3`)
    loadSound(context, utils_songs_to_play[0])
  }
}

function playSound (context, buffer) {
  var source = context.createBufferSource()
  source.onended = function () {
    utils_songs_to_play.shift()
    if (utils_songs_to_play.length) {
      loadSound(context, utils_songs_to_play[0])
    } else {
      utils_sound_playing = false
    }
  }
  source.buffer = buffer
  source.connect(context.destination)
  source.start(0)
}

function debug (msg) {
  console.log('MSG DEBUG=> ', msg)
  return `MSG DEBUG => ${msg}`
}

function ws_connect(ip, port, widget_id, device_id, ip_screen, websocket_token, type, processFunction) {
  if (! ip || ip === 'undefined') return
  let url = `ws://${ip}:${port}/websocket`
  // console.log(url)
  utils_ws = new WebSocket(url)

  // console.log(`widget ws_connect - ws://${ip}:${port}/websocket`)

  utils_ws.onopen = function () {
    console.log('Widget Ws open - widgets.js')
    ws_interval = setInterval(() => {
      wsSend('ignore', {}, widget_id)
    }, 5000)
    if (type === 'queues') {
      console.log('pedindo kiosk config')
      wsSend('kiosk_config_request', null, widget_id, device_id, ip_screen, websocket_token)
    }
    // send default params
    // wsSend('params', default_params, widget_id)
  }

  utils_ws.onmessage = processFunction

  utils_ws.onclose = function (e) {
    console.log('Widget Socket closed - widgets.js')
    clearInterval(ws_interval)
    setTimeout(function () {
      utils_ws = null
      console.log('Widget Socket closed. Reconnect will be attempted in 5 seconds.', e.reason)
      ws_connect(ip, port, widget_id, device_id, ip_screen, websocket_token, type, processFunction)
    }, 5000)
  }

  return utils_ws
}

// get params saved in the database using /params_get and /params_set from the API
function paramsGet (ip, port, widget_id, device_id) {
  let url = ''
  // if (ip && port) {
  //   url = `http://${ip}:${port}http://apis.opalaconsult.com/queues_backoffice/params_get?device_id=${device_id}&widget_id=${widget_id}`
  // } else {
  //   url = `http://apisv2.net-bo.comhttp://apis.opalaconsult.com/queues_backoffice/params_get?device_id=${device_id}&widget_id=${widget_id}`
  // }
  url = `http://apis.opalaconsult.com/queues_backoffice/params_get?device_id=${device_id}&widget_id=${widget_id}&r=${Math.random()}`
  return fetch(url)
    .then(function (res) {
      if (res.status !== 200) return null
      return res.json()
    })
    .catch(function () {
      console.log('error')
      return null
    })
}

function processServerParams (self, port) {
  // checking online params
  let paramsPromisse = paramsGet(self.ip_screen, port, self.widget_id, self.device_id)

  paramsPromisse.then(res => {
    let temParams = res
    // console.log('PARAMS DA TABELA device_params', temParams)
    if (!temParams.success) {
      try {
        temParams = getParams(self.widget_name, self.widget_id)
        if (Object.keys(temParams).length) {
          self.params = self.processParams(temParams.params)
        } else {
          // check error
        }
      } catch (err) {
        console.error(err)
      }
    } else {
      if (temParams.params) {
        setParams(temParams.params, self.widget_name, self.widget_id)
        self.params = self.processParams(temParams.params)
      } else {
        // check error
      }
    }
  }).catch((err) => {
    console.log(err)
  })
}

function getParamsTree (self) {
  // console.error('getParamsTree', self.widget_name)
  let p = new URLSearchParams()
  p.append('device_id', self.device_id)
  p.append('widget_id', self.widget_id)
  p.append('widget_name', self.widget_name)
  p.append('type', self.type)
  return axios({
    url: `${self.url}/get_widget_params_tree`,
    method: 'POST',
    data: p
  })
  .then(res => {
    let ret = []
    if (res.data.params && res.data.params.length) ret = res.data.params
    self.processParamsTree(ret)
  })
}

function getWidgetConfigs (self, device_id, widget_id) {
  const params = new URLSearchParams(window.location.search)
  // console.error('getWidgetConfigs - PARAMS', params)
  self.ip_screen  = params.get('ip_screen')
  self.device_id  = params.get('device_id') || device_id
  self.widget_id  = params.get('widget_id') || widget_id
  self.config_key = params.get('config_key')
  self.area_key   = params.get('area_key')
  self.websocket_token = params.get('websocket_token')
  self.url = params.get('url')
  self.width = params.get('width')
  self.height = params.get('height')
  self.factor_width = params.get('factor_width')
  self.factor_height = params.get('factor_height')
  self.type = params.get('type')

  if (self.ip_screen && self.ip_screen == 'undefined') {
    self.ip_screen = ''
  }

  if (self.websocket_token && self.websocket_token == 'undefined') {
    self.websocket_token = ''
  }

  widget_time = params.get('time')
  if (widget_time) starTime(self, 'YYYY-MM-DD', 'HH:mm:ss')
  let params_post = new URLSearchParams()
  params_post.append('device_id', self.device_id)
  params_post.append('widget_id', self.widget_id)
  axios({
    url: `http://apis.opalaconsult.com/queues_backoffice/get_widget_params_data`,
    method: 'POST',
    data: params_post
  })
  .then(res => {
    if (res.data.success) {
      self.widget_config = self.processConfig(res.data.params)
      // auth related
      try {
        if (!self.widget_config.password || self.widget_config.password === '') {
          self.auth.auth_modal = false
          self.auth.ready = true
        } else {
          self.auth.auth_modal = true
          self.auth.ready = false
          setTimeout(() => {
            self.$refs.password.focus()
          }, 500);
        }
      } catch (error) {
        try {
          self.auth.auth_modal = true
          self.auth.ready = false
          setTimeout(() => {
            self.$refs.password.focus()
          }, 500);
        } catch (error) {}
      }
      // end auth
    }
  })
  // FIM
}

// VALIDA A SENHA
 function checkPass(auth, widget_id, device_id) {
    if (!auth) return
    let pass = auth.auth_pass
    if (!pass) {
      // showNotif('Error')
      return
    }
    let params = new URLSearchParams()
    params.append('device_uuid', device_id)
    params.append('widget_id', widget_id)
    params.append('password', pass)
    axios({
      url: `http://apis.opalaconsult.com/queues_backoffice/widget_login`,
      data: params,
      method: 'POST'
    })
    .then(res => {
      if (res.data.success) {
        auth.auth_modal = false
        auth.auth_pass = ''
        auth.ready = true
        setTimeout(() => {
          location.reload()
        }, 3600000);
      } else {
        // self.showNotif('Invalid password')
      }
    })
    .catch((err) => {
      console.log('erro', err)
    })
  }

//  function showNotif (msg) {
//     $q.notify({
//       message: msg,
//       color: 'negative'
//     })
//   }

function updateTimeFromLatitude (latitude, longitude) {
  if (!latitude || !longitude) return
  axios({
    method: 'get',
    url: `https://api.ipgeolocation.io/timezone?apiKey=b01c8471bf9f46278fbb8864fbaade20&lat=${latitude}&long=${longitude}`,
    timeout: 3000
  })
    .then(function (response) {
      let nowdate = new Date(response.data.date_time_txt)
      widget_time_obj = nowdate
      widget_time = nowdate.format('HH:MM:ss')
      widget_date = nowdate.format('yyyy-mm-dd')
  })
}

function processMessages (msg, widget_name, widget_id, context, device_id, websocket_token, queues) {
  let message = JSON.parse(msg.data)

  let w_token_device = websocket_token || ''
  let w_token_message = message.websocket_token || ''

  // token validation
  if (w_token_device && w_token_device === 'undefined') w_token_device = ''
  if (w_token_message && w_token_message === 'undefined') w_token_message = ''
  if (w_token_device !== w_token_message) return null;

  if (queues) {
    if (!message.action) return null
    return message
  } else {
    // make sure widget_id is correct
    if (widget_id && widget_id === 'undefined') widget_id = ''
    if (message.widget_id && message.widget_id === 'undefined') message.widget_id = ''
    if (!message.widget_id) return null
    if (!message.action) return null
    if (message.widget_id !== widget_id) return null

    if (message.action === 'params') {
      setParams(message.params, widget_name, widget_id)
      return message
    }
    else if (message.action === 'sound' && context) {
      playSounds(context, message.params.sound)
    }
    else if (message.action === 'reload') {
      location.reload()
    }
  }
}

function wsSend (action, params, widget_id, device_id, ip_screen, websocket_token) {
  if (websocket_token && websocket_token === 'undefined') websocket_token = ''
  utils_ws.send(JSON.stringify({
    action: action,
    widget_id: widget_id,
    origin: 'browser',
    params: params,
    websocket_token: websocket_token || '',
    device_id: device_id,
    listen_ip: ip_screen
  }))
}

function getParams (widget_name, widget_id) {
  // let load = localStorage.getItem(`params_${widget_name}_${widget_id}`)
  // if (load) {
  //   load = JSON.parse(load)
  // } else {
  //   load = {}
  // }
  // console.log('GET PARAMS => ', load)
  // console.log('GET PARAMS => ', load.screensaver_timer)
  return {}
}

function setParams (p, widget_name, widget_id) {
  let curParams = getParams(widget_name, widget_id)

  for (let key in p) {
    curParams[key] = p[key]
  }
  // console.log('SET PARAMS => ', p)
  // console.log('SET PARAMS => ', curParams.screensaver_timer)

  // let insert = JSON.stringify(curParams)
  // localStorage.setItem(`params_${widget_name}_${widget_id}`, insert)
}

function blinkElement (id, duration) {
  let elem = document.getElementById(id)

  if (elem) {
    elem.classList.add('blink')

    setTimeout(() => {
      elem.classList.remove('blink')
    }, duration);
  }
}
